<?php

##################################################
#
# Copyright (c) 2004-2006 OIC Group, Inc.
# Written and Designed by James Hunt
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class favorites {
	static function save($module, $id, $action, $msg=null) {
		if (exponent_users_isLoggedIn()) {
			global $user;
			global $db;
	        	if (!favorites::isSaved($module, $id)) {
        	        	$saveme = new stdClass();
	                	$saveme->module = $module;
		                $saveme->user_id = $user->id;
        		        $saveme->object_id = intval($id);
                		$saveme->action = $action;
		                $saveme->saved_at = time();
        		        $db->insertObject($saveme,"saveme");
                		$ret = empty($_REQUEST['msg']) ? exponent_lang_getText('Item Saved'): $_REQUEST['msg'];
		        } else {
        		        $ret = "You have already saved this item.";
	       		}
		} else {
        		$ret = "You must be logged in to perform this action";
		}
		flash('message', $ret);
		return exponent_users_isLoggedIn();
	}

	static function remove($module, $id=null, $msg=null) {
		if (exponent_users_isLoggedIn()) {
			global $user;
                        global $db;
			
			// setup the where clause
			$where = 'user_id='.$user->id." AND module='".$module."'";
			if (!empty($id)) $where .= ' AND object_id='.$id;
			//remove the object(s)
			eDebug($where);
			$ret = $db->delete('saveme', $where);

			if ($ret) {
				$msg = empty($msg) ? 'Item Removed' : $msg;
				flash ('message', $msg);
			} else {
				flash('error', 'An error was encountered while trying to remove the item');
			}
			return $ret;
		}
	}
	static function get($module, $id=null, $user_id=null) {
		global $user;
		global $db;

		$uid = empty($user_id) ? $user->id : $user_id;
		$where = "user_id=".$uid." AND module='".$module."'";
                if (!empty($id)) $where .= " AND object_id=".intval($id);
                return $db->selectObjects('saveme', $where);
	}

	static function isSaved($module, $id=null) {
		global $user;
		global $db;
		$where = "user_id=".$user->id." AND module='".$module."'";
		if (!empty($id)) $where .= " AND object_id=".intval($id);
        	$obj = $db->selectObject('saveme', $where);
		return (empty($obj)) ? false : true;
	}
}

?>
