<?php

##################################################
#
# Copyright (c) 2004-2006 OIC Group, Inc.
# Copyright 2006 Maxim Mueller
# Written and Designed by James Hunt
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

//Initialize exponent Framework
include_once("exponent.php");
?>
// exponent Javascript Support Systems



//DEPRECATED: functional wrapper around OO API
function exponentJSinitialize() {
    eXp.initialize();   
}

//DEPRECATED: functional wrapper around OO API
function exponentJSregister(func) {
    eXp.register(func);
}

//DEPRECATED: functional wrapper around OO API
function exponentGetCookie(name) {
    eXp.getCookie(name);
}

//DEPRECATED: functional wrapper around OO API
function makeLink() {
    return eXp.makeLink(makeLink.arguments);
}

//DEPRECATED: functional wrapper around OO API
function openWindow(url, name, options) {
    eXp.openWindow(url, name, options);
}

//DEPRECATED: functional wrapper around OO API
function openSelector(mod, dest, vmod, vview) {
    eXp.openSelector(mod, dest, vmod, vview);
}

//DEPRECATED: functional wrapper around OO API
function openContentSelector(mod, dest, view) {
    eXp.openContentSelector(mod, dest, view);
}

//DEPRECATED: functional wrapper around OO API
function sourceSelected(hidden, showPreview, src, desc) {
    eXp.sourceSelected(hidden, showPreview, src, desc);
}

//DEPRECATED: functional wrapper around OO API
function selectAll(prefix,checked) {
    eXp.selectAll(prefix, checked);
}

//DEPRECATED: functional wrapper around OO API
function isOneSelected(prefix, enabledOnly) {
    eXp.isOneSelected(prefix, enabledOnly);
}

// Patch the String object, to make string parsing a little easier in exponent
String.prototype.isValid = function (alpha,numeric,others) {
    for (var i = 0; i < this.length; i++) {
        if (alpha && this.isAlpha(i)) continue;
        if (numeric && this.isNumeric(i)) continue;
        var isGood = false;
        for (var j = 0; j < others.length; j++) {
            if (others[j] == this.charAt(i)) {
                isGood = true;
                continue;
            }
        }
        if (!isGood) return false;
    }
    return true;
}

String.prototype.isNumeric = function(index) {
    var charcode = this.charCodeAt(index);
    return (
        (charcode >= 48 && charcode < 48+10)
    );
}

String.prototype.isAlpha = function(index) {    
    var charcode = this.charCodeAt(index);
    return (
        (charcode >= 65 && charcode < 65+26) ||
        (charcode >= 97 && charcode < 97+26)
    );
}

String.prototype.trim = function() {
    str = this;
    while (1) {
        if (str.substring(str.length - 1, str.length) != " ") break;
        str = str.substr(0,str.length - 1);
    }
    while (1 && str.length > 0) {
        if (str.substring(0,1) != " ") break;
        str = str.substr(1,str.length - 1);
    }
    return str;
}

//introduction of a common namespace object
//TODO: migrate all of E`s JS API to this new object
eXp = new Object();

eXp.LANG = "<?php echo LANG; ?>";
eXp.PATH_RELATIVE = "<?php echo PATH_RELATIVE; ?>";
eXp.URL_FULL = "<?php echo URL_FULL; ?>";
eXp.THEME_RELATIVE = "<?php echo THEME_RELATIVE; ?>";
eXp.ICON_RELATIVE = "<?php echo ICON_RELATIVE; ?>";
eXp.onLoadInits = new Array(); // array of functions
eXp.openWindows = new Array(); // array of window references.

eXp.includeOnce = function(id, file) {
        // do we even have to do something ?
        if (!document.getElementById(id)){
        
            //TODO: check for html spelling, right now we assume XHTML
            // get the head element 
            myHeadElem = document.getElementsByTagName("head").item(0);
        
            myNewElem = document.createElement("script");
            myNewElem.setAttribute("id",id);
            myNewElem.setAttribute("type","text/javascript");
            myNewElem.setAttribute("defer","false");
            myNewElem.setAttribute("src",file);
            myHeadElem.appendChild(myNewElem);
        } else {
            //TODO: write handling for overiding of scripts, e.g. by themes.
        };  
};

eXp.initialize = function() {
    for (i = 0; i < eXp.onLoadInits.length; i++) {
        if(typeof(eXp.onLoadInits[i]) == "String") {
            //new style allows for function parameters
            eval(eXp.onLoadInits[i]);
        } else {
            eXp.onLoadInits[i]();
        }
    }
}   

eXp.register = function(func) {
    eXp.onLoadInits.push(func);
}

eXp.getCookie = function(name) {
    cookiestr = document.cookie;
    var nameIndex = cookiestr.indexOf(name);
    if (nameIndex != -1) { // found the named cookie
        var startOffset = nameIndex+name.length+1;
        var endOffset = cookiestr.indexOf(";",startOffset);
        if (endOffset == -1) endOffset = cookiestr.length;
        return cookiestr.substring(startOffset,endOffset);
    }
    return "";
}

eXp.makeLink = function() {
    var args = eXp.makeLink.arguments;
    var link = eXp.PATH_RELATIVE + "index.php?";
    for (var i = 0; i < args.length; i+=2) {
        if(typeof(args[i]) == "object") {
            for (var j = 0; j < args[i].length; j+=2) {
                var w = args[i][j+1];
                if (w != null && w != "") {
                    link += escape(args[i][j]) + "=" + escape(args[i][j+1]) + "&";
                    //alert(link);
                }
            }
        } else {
            var v = args[i+1];
            if (v != null && v != "") {
                link += escape(args[i]) + "=" + escape(args[i+1]) + "&";
            }
        }
    }

    return link.substr(0,link.length - 1);
}

eXp.openWindow = function(url, name, options) {
    for (key in eXp.openWindows) {
        if (key == name) {
            if (eXp.openWindows[key].focus()) {
                return;
            } else {
                break;
            }
        }
    }
    eXp.openWindows[name] = window.open(url,name,options);
}

eXp.openSelector = function(mod, dest, vmod, vview) {
    var url = eXp.PATH_RELATIVE+"source_selector.php?showmodules="+mod+"&dest="+escape(dest)+"&vmod="+vmod+"&vview="+vview;
    openWindow(url,'sourcePicker','title=no,resizable=yes,toolbar=no,width=900,height=750,scrollbars=yes');
}

eXp.openContentSelector = function(mod, dest, view) {
    var url = eXp.PATH_RELATIVE+"content_selector.php?showmodules="+mod+"&dest="+escape(dest)+"&vmod=containermodule&vview="+view;
    eXp.openWindow(url,'contentPicker','title=no,toolbar=no,width=640,height=480,scrollbars=yes');
}

eXp.sourceSelected = function(hidden, showPreview, src, desc) {
    var hidden = document.getElementById(hidden);
    hidden.value = src;
    if (showPreview){
        //showPreviewCall();
    }
}

eXp.selectAll = function(prefix, checked) {
    elems = document.getElementsByTagName("input");
    for (var key in elems) {
        if (elems[key].type == "checkbox" && elems[key].name.substr(0,prefix.length) == prefix) {
            elems[key].checked = checked;
        }
    }
}

eXp.isOneSelected = function(prefix, enabledOnly) {
    if (typeof enabledOnly == "undefined") {
        enabledOnly = true;
    }
    elems = document.getElementsByTagName("input");
    for (var key in elems) {
        if (elems[key].type == "checkbox" && elems[key].name.substr(0,prefix.length) == prefix) {
            if (enabledOnly && elems[key].checked && !elems[key].disabled) return true;
            if (!enabledOnly && elems[key].checked) return true;
        }
    }
    return false;
}

eXp.i18n = function(i18n_string) {
    if(eXp._TR[i18n_string]) {
        i18n_string = eXp._TR[i18n_string];
    }
    return i18n_string;
}


function divtoggle(id) {
    el = document.getElementById(id);
    if (el.style.display == 'none') {
        el.style.display = 'block';
    } else {
        el.style.display = 'none';
    }
}

//FJD - added for easier javascript debugging

function print_r(input, _indent)
{
    if(typeof(_indent) == 'string') {
        var indent = _indent + ' ';
        var paren_indent = _indent + ' ';
    } else {
        var indent = ' ';
        var paren_indent = '';
    }
    switch(typeof(input)) {
        case 'boolean':
            var output = (input ? 'true' : 'false') + "\n";
            break;
        case 'object':
            if ( input===null ) {
                var output = "null\n";
                break;
            }
            var output = ((input.reverse) ? 'Array' : 'Object') + " (\n";
            for(var i in input) {
                output += indent + "[" + i + "] => " + print_r(input[i], indent);
            }
            output += paren_indent + ")\n";
            break;
        case 'number':
        case 'string':
        default:
            var output = "" + input + "\n";
    }
    return output;
}


YAHOO.namespace("EXPONENT");
EXPONENT = YAHOO.EXPONENT || {};


EXPONENT.LANG = "<?php echo LANG; ?>";
EXPONENT.PATH_RELATIVE = "<?php echo PATH_RELATIVE; ?>";
EXPONENT.URL_FULL = "<?php echo URL_FULL; ?>";
EXPONENT.BASE = "<?php echo BASE; ?>";
EXPONENT.THEME_RELATIVE = "<?php echo THEME_RELATIVE; ?>";
EXPONENT.ICON_RELATIVE = "<?php echo ICON_RELATIVE; ?>";

EXPONENT.AjaxEvent = function() {
    var obj;
    var data = "";
    
    var gatherURLInfo = function (obj){
        json = obj.json ? "&json=1" : "";
        if (obj.form){
            data = YAHOO.util.Connect.setForm(obj.form);
            //slap a date in there so IE doesn't cache
            var dt = new Date().valueOf();
            var sUri = EXPONENT.URL_FULL + "index.php?ajax_action=1" + json + "&yaetime=" + dt;
            return sUri;
        } else if (!obj.action || (!obj.controller && !obj.module)) {
            alert("If you don't pass the ID of a form, you need to specify both a module/controller AND and a cresponding action.");
        } else {
            //slap a date in there so IE doesn't cache
            var dt = new Date().valueOf();
            var modcontrol = (obj.controller) ? "&controller="+obj.controller : "&module="+obj.module;
            var sUri = EXPONENT.URL_FULL + "index.php?ajax_action=1" + modcontrol + "&action=" + obj.action + json + "&yaetime=" + dt + obj.params;
            return sUri;
        }
    }

    return {
        json:0,
        subscribe: function(fn, oScope) {
            if (!this.oEvent) {
                this.oEvent = new YAHOO.util.CustomEvent("ajaxevent", this, false, YAHOO.util.CustomEvent.FLAT);
            }
            if (oScope) {
                this.oEvent.subscribe(fn, oScope, true);
            } else {
                this.oEvent.subscribe(fn);
            }
        },
        fetch: function(obj) {
            if (typeof obj == "undefined" || !obj){
                alert('EXPONENT.ajax requires a single object parameter.');
                return false;
            } else {
                if (typeof(obj.json)!=="undefined"){
                    this.json = obj.json;
                } else {
                    this.json = false;
                }
                var sUri = gatherURLInfo(obj);
                //console.debug(sUri);
                YAHOO.util.Connect.asyncRequest("POST", sUri, {
                success: function (o) {
                    //if we're just sending a request and not needing to do 
                    //anything on the completion, we can skip firing the custtom event
                    if (typeof(this.oEvent)!=="undefined") {
                       
                        //otherwise, we check if we've got SJON coming back to parse
                        if (this.json!==false) {
                            //if so, parse it
                            var oParse = YAHOO.lang.JSON.parse(o.responseText);
                        } else {
                            //if not, it's probably HTML we're going to update a view with
                            var oParse = o.responseText;
                        }
                        //fire off the custome event to do some more stuff with
                        this.oEvent.fire(oParse);
                    }
                },
                    scope: this
                },obj.data);
            }
        }
    }
}



EXPONENT.forms = {
        
    getSelectedRadio: function (formId, inputId){
        var oForm = this.grabForm(formId);
        for (var i=0; i<oForm.elements.length; i++){
            oElement = oForm.elements[i];
            oValue = oElement.value;

            switch(oElement.type)
            {
                case 'radio':
                    if(oElement.checked && oElement.name==inputId){
                        return oValue;
                    }
                    break;
            }
        }
        return "no selected radios found";
    },
    setSelectedRadio: function (formId, inputId, rValue){
        var oForm = this.grabForm(formId);
        for (var i=0; i<oForm.elements.length; i++){
            oElement = oForm.elements[i];
            oValue = oElement.value;

            switch(oElement.type)
            {
                case 'radio':
                    if(oElement.name==inputId && oElement.value==rValue){
                        oElement.checked = true;
                        return "Radio "+oElement.name+" set to value "+oElement.value;
                    }
                    break;
            }
        }
        return "No value matching the one provided was found in this radio group";
    },
    getSelectValue: function (selectid) {
        var selectmenu = YAHOO.util.Dom.get(selectid);
        return selectmenu.options[selectmenu.selectedIndex].value;
    },
    setSelectValue: function (selectid,setVal) {
        var selectmenu = YAHOO.util.Dom.get(selectid);
        return selectmenu.value = setVal;
    },
    addSelectOption: function (selectid,oVal,text) {
        var selectmenu = YAHOO.util.Dom.get(selectid);
        selectmenu.options[selectmenu.length] = new Option(text, oVal);
        return oVal;
    },
    grabForm: function (formId){
        var oForm;
        if(typeof formId == 'string'){
            // Determine if the argument is a form id or a form name.
            // Note form name usage is deprecated, but supported
            // here for backward compatibility.
            oForm = (document.getElementById(formId) || document.forms[formId]);
        }
        else if(typeof formId == 'object'){
            // Treat argument as an HTML form object.
            oForm = formId;
        }
        else{
            return;
        }
        return oForm;
    }
};


