<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Adam Kessler
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class discounts extends expRecord {
    public $table = 'discounts';
    public $validates = array(
        'presence_of'=>array(
            'title'=>array('message'=>'Name is a required field.'),
            'discount_type'=>array('message'=>'Discount Type is a required field.'),
            'discount_amount'=>array('message'=>'Amount is a required field.'),
        ));
        
    public $apply_rules = array(1=>'Apply to whole cart before shipping', 2=>'Apply to whole cart after shipping');
    public $discount_types = array(1=>'%', 2=>'$');
    
    public static function getUsersDiscounts(&$order) {
        $no_more_discounts = false;
        
        $groupdiscounts = groupdiscounts::getGroupDiscountsForUser();
        foreach($groupdiscounts as $discount) {
            if ($discount->discount_type == 2 && $no_more_discounts == false) {
                $order->cart_discounts += $discount->discount_amount;
                $no_more_discounts = $discount->dont_allow_other_discounts;
            } elseif ($discount->discount_type == 1 && $no_more_discounts == false) {
                $order->product_discounts += $discount->discount_amount;
                $no_more_discounts = $discount->dont_allow_other_discounts;
            }
        }
    }
    
#    public static function getUsersDiscounts(&$order) {
#        $groupdiscounts = groupdiscounts::getGroupDiscountsForUser();
#        foreach($groupdiscounts as $discount) {
#            if ($discount->discount_type == 2) {
#                $order->cart_discounts[] = $discount;
#            } elseif ($discount->discount_type == 1) {
#                $order->product_discounts[] = $discount;
#            }
#        }
#    }
    
#    public static function calculate ($discount, $order) {
#        // just subtract a dollar amount...we don't need to worry about the apply_when parameter in this case
#        if ($discount->discount_type == 2) {
#            $amount_off = $discount->discount_amount;
#        } elseif ($discount->discount_type == 1) {
#            // if the discount type is a percentage then we need to find out when to apply it 
#            // to the order
#            if ($discount->apply_when == 1) {
#                $amount_off = $order->total * ($discount->discount_amount * .01);
#            } elseif ($discount->apply_when == 1) {
#                $total_shipping = $order->total + $order->shipping_total;
#                $amount_off = $total_shipping * ($discount->discount_amount * .01);
#            }
#        }
#        
#        return $amount_off;
#    }
}

?>
