<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Adam Kessler
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class administrationController extends expController {
    public $basemodel_name = 'expRecord';
    public $useractions = array('quicklinks'=>'Display Quicklinks Menu');
    public $add_permissions = array('administrate'=>'Manage Administration');
    
    function name() { return $this->displayname(); } //for backwards compat with old modules
    function displayname() { return "Administration Controls (*Experimental*)"; }
    function description() { return "This is the beginnings of the new Administration Module"; }
    function author() { return "Adam Kessler - OIC Group, Inc"; }
    function hasSources() { return true; }
    function hasViews() { return true; }
    function hasContent() { return true; }
    function supportsWorkflow() { return false; }
    function isSearchable() { return false; }
    
    public function quicklinks() {
        //eDebug($this);
    }
    
    public function manage_unused_tables() {
        global $db;
        
        expHistory::set('managable', $this->params);
        $unused_tables = array();
        $tables = $db->getTables();
        //eDebug($tables);
        foreach($tables as $table) {
            $basename = str_replace(DB_TABLE_PREFIX.'_', '', $table);
            $oldpath = BASE.'datatypes/definitions/'.$basename.'.php';
            $mvcpath = BASE.'framework/core/database/definitions/'.$basename.'.php';
            if (!file_exists($oldpath) && !file_exists($mvcpath) && !stristr($basename, 'formbuilder')) {
                $unused_tables[$basename]->name = $table;
                $unused_tables[$basename]->rows = $db->countObjects($basename);
            }
        }
        
        assign_to_template(array('unused_tables'=>$unused_tables));
    }
    
    public function delete_unused_tables() {
        global $db;

        $count = 0;
        foreach($this->params['tables'] as $del=>$table) {
            $basename = str_replace(DB_TABLE_PREFIX.'_', '', $table);
            $count += $db->dropTable($basename);
        }
        
        flash('message', 'Deleted '.$count.' unused tables.');
        expHistory::back();
    }
    
    public function toolbar() {
        global $user;
        if (!$user->isAdmin()) return false;
        $menu = array();
		$dirs = array(BASE.'framework/modules/administration/menus', BASE.'themes/'.DISPLAY_THEME_REAL.'/modules/administration/menus');
		foreach ($dirs as $dir) {
		    if (is_readable($dir)) {
			    $dh = opendir($dir);
			    while (($file = readdir($dh)) !== false) {
				    if (substr($file,-4,4) == '.php' && is_readable($dir.'/'.$file) && is_file($dir.'/'.$file)) {
					    $menu[substr($file,0,-4)] = include($dir.'/'.$file);
				    }
			    }
		    }
		}

        // sort the menus alphabetically by filename
		ksort($menu);		
		$sorted = array();
		foreach($menu as $m) $sorted[] = $m;
        
        
        //slingbar position
        if (expSession::exists("slingbar_top")){
            $top = expSession::get("slingbar_top");
        } else {
            $top = SLINGBAR_TOP;
        }
        
		assign_to_template(array('menu'=>json_encode($sorted),"top"=>$top));
    }
    
    public function index() {
        redirect_to(array('controller'=>'administration', 'action'=>'toolbar'));
    }
    
    public function update_SetSlingbarPosition() {
       expSession::set("slingbar_top",$this->params['top']);
    }
    
}

?>
