<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Adam Kessler
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

if (!defined('EXPONENT')) exit('');

$i18n = exponent_lang_loadFile('modules/administrationmodule/tasks/coretasks.php');
$script = "

    var filepickerwindow = function (){
        win = window.open('".makeLink($params=array('controller'=>'file','action'=>'picker','ajax_action'=>'1','update'=>'noupdate'))."', 'IMAGE_BROWSER','left=0,top=0,scrollbars=yes,width=800,height=600,toolbar=no,resizable=yes,status=0');
        if (!win) {
            //Catch the popup blocker
            alert(\"Your popup blocker has prevented the file manager from opening\");
        }
    }
    
    YAHOO.util.Event.on('filemanager','click',filepickerwindow);
    
";

exponent_javascript_toFoot('adminfilemanager', '', null, $script);


return array(
    'text'=>'<img src="'.URL_FULL.'themes/common/skin/admintoolbar/expbar.png">',
    'classname'=>'site',
    'submenu'=>array(
        'id'=>'admin',
        'itemdata'=>array(
            array(
                'text'=>"File Manager",
                'id'=>"filemanager",
                'url'=>"#",
            ),
            array(
                'text'=>$i18n['configuration'],
                'submenu'=>array(
                    'id'=>'configure',
                    'itemdata'=>array(
                        array(
                            'text'=>$i18n['configure_site'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'configuresite')),
                        ),
                        array(
                            'text'=>$i18n['system_info'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'sysinfo')),
                        ),
                        array(
                            'text'=>$i18n['file_types'],
			                'url'=>makeLink(array('module'=>'filemanager','action'=>'admin_mimetypes')),
                        ),
                        array(
                            'text'=>$i18n['workflow_policies'],
			                'url'=>makeLink(array('module'=>'workflow','action'=>'admin_manage_policies')),
                        ),
                        array(
                            'text'=>'Spider Site',
			                'url'=>makeLink(array('module'=>'search','action'=>'spider')),
                        ),
                        array(
                            'text'=>'Configure Editor Toolbar',
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'htmlarea_configs')),
                        ),
                    ),                        
                ),
            ),
            array(
                'text'=>'Developer Tools',
                'submenu'=>array(
                    'id'=>'development',
                    'itemdata'=>array(
                        array(
                            'text'=>$i18n['toggle_dev'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'toggle_dev')),
                        ),
                        array(
                            'text'=>$i18n['rebuild_css'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'remove_css')),
                        ),
                        array(
                            'text'=>$i18n['clear_smarty'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'clear_smarty_cache')),
                        ),
                        array(
                            'text'=>$i18n['toggle_maint'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'toggle_maintenance')),
                        ),
                    ),                        
                ),
            ),
            array(
                'text'=>$i18n['user_management'],
                'submenu'=>array(
                    'id'=>'usermanagement',
                    'itemdata'=>array(
                        array(
                            'text'=>$i18n['user_accounts'],
			                'url'=>makeLink(array('controller'=>'users','action'=>'manage')),
			                'icon'=>ICON_RELATIVE."userperms.png"
                        ),
                        array(
                            'text'=>$i18n['group_accounts'],
			                'url'=>makeLink(array('module'=>'users','action'=>'manage_groups')),
			                'icon'=>ICON_RELATIVE."groupperms.png"
                        ),
                        array(
                            'text'=>$i18n['profile_definitions'],
			                'url'=>makeLink(array('module'=>'users','action'=>'manage_extensions')),
			                'icon'=>ICON_RELATIVE."groupperms.png"
                        ),
                        array(
                            'text'=>$i18n['user_sessions'],
			                'url'=>makeLink(array('module'=>'users','action'=>'manage_sessions')),
			                'icon'=>ICON_RELATIVE."groupperms.png"
                        ),
                    ),                        
                ),
            ),
            array(
                'text'=>$i18n['extensions'],
                'submenu'=>array(
                    'id'=>'extensions',
                    'itemdata'=>array(
                        array(
                            'text'=>$i18n['manage_modules'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'managemodules')),
                        ),
                        array(
                            'text'=>$i18n['manage_themes'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'managethemes')),
                        ),
                        array(
                            'text'=>$i18n['manage_tags'],
			                'url'=>makeLink(array('module'=>'expTag','action'=>'manage')),
                        ),
                        array(
                            'text'=>$i18n['manage_wizards'],
			                'url'=>makeLink(array('module'=>'wizardmodule','action'=>'manage_wizards')),
                        ),
                        array(
                            'text'=>$i18n['manage_subsystems'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'managesubsystems')),
                        ),
                        array(
                            'text'=>$i18n['upload_extension'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'upload_extension')),
                        ),
#                        array(
#                            'text'=>'Manage Bots',
#			                'url'=>makeLink(array('module'=>'bots','action'=>'manage_bots')),
#                        ),
                    )
                )
            ),
            array(
                'text'=>$i18n['database'],
                'submenu'=>array(
                    'id'=>'database',
                    'itemdata'=>array(
                        array(
                            'text'=>$i18n['install_tables'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'installtables')),
                        ),
                        array(
                            'text'=>$i18n['import_data'],
			                'url'=>makeLink(array('module'=>'importer','action'=>'list_importers')),
                        ),
                        array(
                            'text'=>$i18n['export_data'],
			                'url'=>makeLink(array('module'=>'importer','action'=>'list_exporters')),
                        ),
                        array(
                            'text'=>$i18n['archived_modules'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'orphanedcontent')),
                        ),
                        array(
                            'text'=>$i18n['optimize_database'],
			                'url'=>makeLink(array('module'=>'administrationmodule','action'=>'optimizedatabase')),
                        ),
                        array(
                            'text'=>'Remove Unused Tables',
			                'url'=>makeLink(array('controller'=>'administration','action'=>'manage_unused_tables')),
                        ),
                    )
                )
            ),
            array(
                'text'=>'Migration',
                'submenu'=>array(
                    'id'=>'migration',
                    'itemdata'=>array(
                        array(
                            'text'=>'Configure Migration Settings',
			                'url'=>makeLink(array('module'=>'migration','action'=>'configure')),
                        ),
                        array(
                            'text'=>'Migrate Pages',
			                'url'=>makeLink(array('module'=>'migration','action'=>'manage_pages')),
                        ),
                        array(
                            'text'=>'Migrate Content (Modules)',
			                'url'=>makeLink(array('module'=>'migration','action'=>'analyze_site')),
                        ),
                    )
                )
            ),
        ),
     )
);

?>
