<?php
##################################################
#
# Copyright (c) 2004-2006 OIC Group, Inc.
# Created by Adam Kessler @ 05/28/2008
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class creditcard extends billingcalculator {
	function name() { return 'Credit Card'; }
	function hasConfig() { return false;}
	function hasUserForm() { return false;}
	function isOffsite() { return false; }
	function isSelectable() { return false; }
	
	public $title = 'Credit Card';
	public $payment_type = 'Credit Card';
	
	public $cards = array("AmExCard"=>"American Express","DiscoverCard"=>"Discover","MasterCard"=>"MasterCard", "VisaCard"=>"Visa");
	public $card_images = array(
		"AmExCard"=>"path/to/image.png",
		"DiscoverCard"=>"path/to/image.png",
		"MasterCard"=>"path/to/image.png", 
		"VisaCard"=>"path/to/image.png"
	);
	
    function userForm() {
		// make sure we have some billing options saved.
		//if (empty($this->opts)) return false;
		
		//exponent_javascript_toFoot('creditcard',"",null,'', URL_FULL.'subsystems/forms/js/AuthorizeNet.validate.js');
		//$opts->first_name = isset($this->opts->first_name) ? $this->opts->first_name : null;
		//$opts->last_name = isset($this->opts->last_name) ? $this->opts->last_name : null;
		$this->opts = exponent_sessions_get('billing_options');
		$opts->cc_type = isset($this->opts->cc_type) ? $this->opts->cc_type : null;
		$opts->cc_number = isset($this->opts->cc_number) ? $this->opts->cc_number : null;
		$opts->exp_month = isset($this->opts->exp_month) ? $this->opts->exp_month : null;
		$opts->exp_year = isset($this->opts->exp_year) ? $this->opts->exp_year : null;
		$opts->cvv = isset($this->opts->cvv) ? $this->opts->cvv : null;

		$form = '';
		/* FIXME: hard coded options!!
	  	if ($config_object->accept_amex) $cards["AmExCard"] = "American Express";
		if ($config_object->accept_discover) $cards["DiscoverCard"] = "Discover";
		if ($config_object->accept_mastercard) $cards["MasterCard"] = "MasterCard";
		if ($config_object->accept_visa) $cards["VisaCard"] = "Visa";
		*/
		//$fname = new textcontrol($opts->first_name);
		//$lname = new textcontrol($opts->last_name);
		
		$cardtypes = new dropdowncontrol($opts->cc_type,$this->getAvailableCards());
		$cardnumber = new textcontrol($opts->cc_number,20,false,20,"integer", true);
		$expiration = new monthyearcontrol($opts->exp_month, $opts->exp_year);
		$cvv = new textcontrol($opts->cvv,4,false,4,"integer", true);
		$cvvhelp = new htmlcontrol("<a href='http://en.wikipedia.org/wiki/Card_Verification_Value' target='_blank'>What's this?</a>");

		$cardtypes->id = "cc_type";
		$cardnumber->id = "cc_number";
		$expiration->id = "expiration";
		$cvv->id = "cvv";
		$cvv->size = 5;
		$cvvhelp->id = "cvvhelp";

		//$form .= $fname->toHTML("First Name", "first_name");
		//$form .= $lname->toHTML("Last Name", "last_name");
		$form .= $cardtypes->toHTML("Card Type", "cc_type");
		$form .= $cardnumber->toHTML("Card #", "cc_number");
		$form .= "<strong class=\"example\">Example: 1234567890987654</strong>";
		$form .= $expiration->toHTML("Expiration", "expiration");
		$form .= $cvv->toHTML("CVV #", 'cvv');
		$form .= $cvvhelp->toHTML('', 'cvvhelp');
		
		return $form;	
	}
	
	public function getAvailableCards() {
	    $configdata = unserialize($this->config);
	    $avaiablecards = array();
	    foreach($configdata['accepted_cards'] as $card) {
	        $availablecards[$card] = $this->cards[$card];
	    }
	    
	    return $availablecards;
	}
	
	//process user input. This function should return an object of the user input.
	//the returnd object will be saved in the session and passed to post_process.
	//If need be this could use another method of data storage, as long post_process can get the data.
	function userFormUpdate($params) {
		expValidator::validate(array('presence_of'=>'cc_number','presence_of'=>'cvv'), $params);
		$this->opts = null;
        //$this->opts->first_name = $params["first_name"];
        //$this->opts->last_name = $params["last_name"];
        $this->opts->cc_type = $params["cc_type"];
        $this->opts->cc_number = $params["cc_number"];
        $this->opts->exp_month = $params["expiration_month"];
        $this->opts->exp_year = $params["expiration_year"];
        $this->opts->cvv = $params["cvv"];	
		return $this->opts;
	}
	
	//Should return html to display user data.
	function userView($opts) {
	    if (empty($opts)) return false;
		$html = '';
		$html .= '<table id="ccinfo" border=0 cellspacing=0 cellpadding=0><tbody>';
		$html .= '<tr class="odd"><td>Type of Credit Card: </td><td>'.$opts->cc_type.'</td></tr>';
		$html .= '<tr class="even"><td>Credit Card Number: </td><td>'.'xxxx-xxxx-xxxx-'.substr($opts->cc_number, -4). '</td></tr>';
		$html .= '<tr class="odd"><td>Expires on: </td><td>'.$opts->exp_month.'/'.$opts->exp_year.'</td></tr>';
		$html .= '<tr class="even"><td>CVV/Security Number: </td><td>'.$opts->cvv.'</td></tr>';
		$html .= '<tbody></table>';
		return $html;
	}
	
}

?>

