{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<div id="editproduct" class="module store edit hide exp-skin-tabview">

    {if $record->id != ""}
        <h1>Edit Information for {$modelname}</h1>
    {else}
        <h1>New {$modelname}</h1>
    {/if}

    {script unique="prodtabs" yuimodules="tabview, element"}
    {literal}
        var tabView = new YAHOO.widget.TabView('demo');
        YAHOO.util.Dom.removeClass("editproduct", 'hide');
        var loading = YAHOO.util.Dom.getElementsByClassName('loadingdiv', 'div');
        YAHOO.util.Dom.setStyle(loading, 'display', 'none');
        
    {/literal}
    {/script}

    {form action=update}
        {control type="hidden" name="id" value=$record->id}
        <div id="demo" class="yui-navset">
            <ul class="yui-nav">
            <li class="selected"><a href="#tab1"><em>General</em></a></li>
            <li><a href="#tab2"><em>Pricing</em></a></li>
            <li><a href="#tab3"><em>Files</em></a></li>
            <li><a href="#tab4"><em>Quantity</em></a></li>
            <li><a href="#tab5"><em>Shipping</em></a></li>
            <li><a href="#tab6"><em>Categories</em></a></li>
            <li><a href="#tab7"><em>Options</em></a></li>
            <li><a href="#tab8"><em>Featured</em></a></li>
            <li><a href="#tab9"><em>SEO</em></a></li>
            </ul>            
            <div class="yui-content">
            <div id="tab1">
                {control type="text" name="model" label="Model #" value=$record->model}
                {control type="text" name="title" label="Title" value=$record->title}
                {control type="dropdown" name="companies_id" label="Manufacturer" frommodel=company value=$record->companies_id}
                {control type="textarea" name="summary" label="Product Summary" rows=3 cols=45 value=$record->summary}
                {control type="editor" name="body" label="Product Description" height=250 value=$record->body}          
            </div>
            <div id="tab2">
                <fieldset>
                <legend>General Pricing</legend>
                    <table>
                    <tr>
                        <td>{control type="text" name="base_price" label="Base Price" value=$record->base_price filter=money}</td>
                        <td>{control type="text" name="special_price" label="Special Price" value=$record->special_price filter=money}</td>
                    </tr>
                    <tr>
                        <td colspan="2">{control type="checkbox" name="use_special_price" label="Use Special Price" value=$record->use_special_price}</td>
                    </tr>
                    </table>
                </fieldset>
                <fieldset>
                <legend>Quantity Discounts</legend>
                    <p>
                        Quantity discounts are discounts that get applied when a customer purchases a certain 
                        amount of this product. You can configure how the discounts work by setting the discount
                        rules below. 
                    </p>
                    <table class="qty-discount">
                    <tr>
                        <td>If a customer purchases more than </td>
                        <!--td>{control type="dropdown" name="quantity_discount_num_items_mod" label=" " items=$record->quantity_discount_items_modifiers value=$record->quantity_discount_num_items}</td-->
                        <td>{control type="text" name="quantity_discount_num_items" label=" " value=$record->quantity_discount_num_items size=3 filter=integer}</td>
                        <td>items, than discount the price by</td>
                        <td>{control type="text" name="quantity_discount_amount" label=" " value=$record->quantity_discount_amount size=3 filter=decimal}
                        <td>{control type="dropdown" name="quantity_discount_amount_mod" label=" " items=$record->quantity_discount_amount_modifiers value=$record->quantity_discount_amount_mod}</td>
                    </tr>
                    <tr>
                        <td colspan="6">{control type="checkbox" name="quantity_discount_apply" label="Only apply discount to the items over the discount limit" value=1 checked=$record->quantity_discount_apply}</td>
                    </tr>
                    </table>
                </fieldset>                 
                {control type="dropdown" name="tax_class_id" label="Tax Class" frommodel=taxclass key=id display=name includeblank="-- No Tax Required --" value=$record->tax_class_id}
            </div>
            <div id="tab3">
                {control type=files name=images label="Product Images" subtype="images" value=$record->expFile}
                {control type=files name=brochures label="Product Brochures/Docs" subtype="brochures" value=$record->expFile}
            </div>
            <div id="tab4">
                {control type="text" name="quantity" label="Quantity" value=$record->quantity}
                {control type="text" name="minimum_order_quantity" label="Minimum order quantity" value=$record->minimum_order_quantity}
                {control type="checkbox" checked=1 name="allow_partial" label="Allow partial quantities?" value=$record->allow_partial}
                {control type="checkbox" name="is_hidden" label="Hide Product" value=$record->is_hidden}
                {control type="radiogroup" name="availability_type" label="Quantity Display" items=$record->quantity_display checked=$record->availability_type}
                {control type="textarea" name="availability_note" label="Note to display when product is not available" rows=5 cols=45 value=$record->availability_note}
            </div>
            <div id="tab5">
                {control type="checkbox" name="no_shipping" label="This item doesn't require shipping" value=1 checked=$record->no_shipping}
                {control type="dropdown" name="required_shipping_calculator_id" id="required_shipping_calculator_id" label="Required Shipping Service" includeblank="--- Select a shipping service ---" items=$shipping_services value=$record->required_shipping_calculator_id onchange="switchMethods();"}
                {foreach from=$shipping_methods key=calcid item=methods name=sm}
                    <div id="dd-{$calcid}" class="hide methods">
                    {control type="dropdown" name="required_shipping_methods[`$calcid`]" label="Shipping Methods" items=$methods value=$record->required_shippng_method}
                    </div>
                {/foreach}
                {control type="text" name="weight" label="Item Weight" size=4 filter=decimal value=$record->weight}
                {control type="text" name="width" label="Width (in inches)" size=4 filter=decimal value=$record->width}
                {control type="text" name="height" label="Height (in inches)" size=4 filter=decimal value=$record->height}                
                {control type="text" name="length" label="Length (in inches)" size=4 filter=decimal value=$record->length}
            </div>
            <div id="tab6">
                {control type="tagtree" name="managecats" id="managecats" controller="store" model="storeCategory" draggable=false checkable=true values=$record->storeCategory}
            </div>
            <div id="tab7">
                <h2>Add options to your product</h2>
                {include file="`$smarty.const.BASE`framework/modules/ecommerce/products/views/product/options_partial.tpl"}
            </div>
            <div id="tab8">
                {control type="checkbox" name="is_featured" label="Feature this product?" value=1 checked=$record->is_featured}
                {control type=files name="featured_image" label="Featured Product Images" subtype="featured_image" value=$record->expFile}
            </div>
            <div id="tab9">
                <h2>SEO Settings</h2>
                {control type="text" name="sef_url" label="SEF URL" value=$record->sef_url}
                {control type="text" name="meta_title" label="Meta Title" value=$record->meta_title}
                {control type="textarea" name="meta_keywords" label="Meta Description" value=$record->meta_description}
                {control type="textarea" name="meta_description" label="Meta Keywords" value=$record->meta_keywords}
            </div>
            </div>
        </div>
        {control type="buttongroup" submit="Save Product" cancel="Cancel"}
    {/form}
</div>
<div class="loadingdiv">Loading</div>

{script unique="prodedit"}
{literal}
    function switchMethods() {
        var dd = YAHOO.util.Dom.get('required_shipping_calculator_id');
        var methdd = YAHOO.util.Dom.get('dd-'+dd.value);

        var otherdds = YAHOO.util.Dom.getElementsByClassName('methods', 'div');
        
        for(i=0; i<otherdds.length; i++) {
            if (otherdds[i].id == 'dd-'+dd.value) {
                YAHOO.util.Dom.setStyle(otherdds[i].id, 'display', 'block');
            } else {
                YAHOO.util.Dom.setStyle(otherdds[i].id, 'display', 'none');
            }
            
        }
        YAHOO.util.Dom.setStyle(methdd, 'display', 'block');
        //console.debug(methdd);
        //console.debug(dd.value);
    }
    YAHOO.util.Event.onDOMReady(switchMethods);
{/literal}
{/script}
