{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}
<div id="expresscheckout" class="cart checkout exp-skin hide">
    <h1>{$moduletitle|default:"Express Checkout"}</h1>
    
    {if $order->forced_shipping == true}
    <ul id="forcedshipping" class="queue error">
        <li>{$order->product_forcing_shipping->title} requires you to ship this order via {$shipping->shippingmethod->option_title}</li>
    </ul>
    {/if}

    <div class="totals">
        <div class="details">
            Total: <span class="carttotal">{currency_symbol}{$order->total|number_format:2}</span>
        </div>
    </div>

    <div class="cartitems separate">
        <p>You’ve got <strong>{$order->orderitem|@count}</strong> item{if $order->orderitem|@count > 1}s{/if} in your cart. <a id="expandcart" href="#" class="ecom-link">Show them?<span></span></a></p>
        <div id="shoppingcartwrapper">
            {chain controller=cart action=show view=show_cart_only}
        </div>
    </div>
    <div style="clear:both"></div>
    <div id="billingadshippinginfo">
        {if $order->shipping_required == true}
        <div class="shippingdetails separate">
            {if $shipping->selectable_calculators|@count > 1}

            {/if}
        
            {if $shipping->shippingmethod->option!=""}
                {foreach from=$shipping->pricelist item=option}
                    {if $option.id == $shipping->shippingmethod->option}{assign var=shpMthdOp value=$option}{/if}
                {/foreach}
            {else}
                {foreach name="gtfoi" from=$shipping->pricelist item=option}
                    {if $smarty.foreach.gtfoi.first}{assign var=shpMthdOp value=$option}{/if}
                {/foreach}
            {/if}
            <div class="shipping-info">
                <h2>Your Shipping Information</h2>
                {if $order->orderitem|@count>1 && $shipping->splitshipping == false && $order->forced_shipping == false}
                    <a id="miltiaddresslink" class="ecom-link {if hideMultiShip == 1}hide{/if}" href="{link action=splitShipping}">Ship to multiple addresses</a>
                {/if}
                
                {if $shipping->selectable_calculators|@count > 1}{assign var=multicalc value=1}{/if}
                {if !$shipping->address->id}{assign var=noShippingPrices value=1}{/if}
                
                <h3>Shipping Method{if multicalc}s{/if}</h3>
                {if $multicalc}
                
                
                {if $order->forced_shipping == true}
                    <p>Your order requires <strong>{$shipping->shippingmethod->option_title}</strong></p>
                {else}
                    <p{if $noShippingPrices} class="hide"{/if}><strong id="cur-calc">{if $shipping->calculator->id}{$shipping->calculator->title}{else}No service selected{/if}</strong>  -  <a href="#" id="servicepicker">Select a Service</a></p>

                    <div id="calculators" class="exp-dropmenu">
                        <div class="hd"><span class="type-icon"></span>Select a Shipping Service</div>
                        <div class="bd">
                            <div>
                                <ul>
                                {foreach key=key from=$shipping->selectable_calculators item=calc}
                                {*if $option.id == $shipping->shippingmethod->option}{assign var=selected value=true}{else}{assign var=selected value=false}{/if*}
                                    <li><a rel="{$key}" href="#" class="servopt">{$calc}</a></li>
                                {/foreach}
                                </ul>
                                {form name=SelShpCal controller=shipping action=selectShippingCalculator}
                                    {control type=hidden name=shippingcalculator_id id=shipcalc_id value=$shipping->calculator->id}
                                {/form}
                            </div>
                        </div>
                    </div>
                {/if}
                {/if}
                {if $shipping->splitshipping == false}

                <div style="clear:both"></div>
                
                <div id="shipping-services">
                    {include file="`$smarty.const.BASE`framework/modules/ecommerce/views/shipping/renderOptions.tpl"}
                </div>

                <h3>Shipping Address</h3>
                <a class="ordermessage exp-ecom-link" href="#" rel="{$shipping->shippingmethod->id}">Add a Gift Message to this Order<span></span></a>
                
                <div class="shipping-address">
                    <div id="shpAddSwp">
                        {if $shipping->address->id == ''}
                            No address yet
                        {else}
                            {$shipping->address|address}
                        {/if}
                    </div>    
                    
                    <div class="bracket{if !$shipping->address->id} hide{/if}">
                        <a id="shippingaddresslink" class="ecom-link changeselection changeaddress" href="#">Change Address?</a>                        
                    </div>
                    
                </div>
                <div style="clear:both"></div>
                <div id="shippingaddressswitch"  class="addressswitch exp-dropmenu">
                    <div class="hd"><span class="type-icon"></span>Switch your Shipping Address</div>
                    <div class="bd">
                        <a href="#" class="addAddressLink" id="addShippingAddressLink">Add an Address</a>
                        {form controller=shipping name=shippingaddy action="setAddress"}
                        <div id="shippingAddressPicker" >
                            {foreach from=$addresses item=address}                  
                            <address id="addy{$address->id}" class="address {if $address->id == $shipping->address->id}current {/if}shpAddSwp">
                                {$address->firstname} {$address->middlename} {$address->lastname} {br}
                                {$address->address1}{if $address->address2}, {$address->address2}{br}{else}{br}{/if}
                                {$address->city}, {$address->statename} {$address->zip}
                            </address>
                            {/foreach}
                        </div>
                        <div class="tohide">
                            {control type=dropdown class="addydd" id=shipping_address name=shipping_address label=" " items=$addresses_dd value=$address->id}
                            {control type=buttongroup id="shipSwitcher" name="shipSwitcher" submit=Change}
                        </div>
                        {/form}
                    </div>
                </div>
                {else}

                {* else, we have split shipping *}
                <a id="miltiaddresslink" class="ecomlink-link" href="{link action=splitShipping}">Edit Shipping Information</a>
            
                {foreach from=$shipping->splitmethods item=method}
                    <div class="splitaddress">
                        <h4>{$order->countOrderitemsByShippingmethod($method->id)} items will be shipped to:</h4>
                        <a class="ordermessage exp-ecom-link" href="#" rel="{$method->id}">Add a Gift Message to this Order <span></span></a>
                        <address>
                            {$method->firstname} {$method->middlename} {$method->lastname}{br}
                            {$method->address1}{br}
                            {if $method->address2 != ""}{$method->address2}{br}{/if}
                            {$method->city}, {$method->state|statename:abv}, {$method->zip}
                        </address>
                    </div>
                {/foreach}
                
                {/if}
            </div>
            {* end split shipping *}
            {/if} {* end shipping required check *}
            <div id="ordermessageform"  class="exp-form">
                    <div class="hd">Add a Gift Message</div>
                    <div class="bd"><span class="type-icon"></span>
                        {form controller=shipping name=omform action="leaveMessage"}
                            {control type=hidden name=shippingmessageid id=shippingmessageid value="0"}
                            {control type=hidden name=nosave id=nosave value="0"}
                            {control type=text name=shpmessageto id=shpmessageto label="To"}
                            {control type=text name=shpmessagefrom id=shpmessagefrom label="From"}
                            {control type=textarea name=shpmessage id=shpmessage label="Message"}
                            {control type=buttongroup name="savemessage" id="savemessage" submit="Save Message"}
                        {/form}
                    </div>
                </div>
        </div>
        <div class="billingdetails separate">
            <h2>Your Billing Information</h2>
            <h3>Your billing address</h3>
            
            <div class="billing-address">
                <div id="bllAddSwp">
                    {if $billing->address->id == ''}
                        You have not selected an address yet.
                    {else}
                        {$billing->address|address}
                    {/if}
                </div>
                <div class="bracket">
                    <a id="billingaddresslink" class="ecom-link changeselection changeaddress" href="#">Change Address?</a>
                </div>
            </div>
        
            <div id="billingaddressswitch" class="addressswitch exp-dropmenu">
                <div class="hd"><span class="type-icon"></span>Switch your Billing Address</div>
                <div class="bd">
                    <a id="addBillingAddressLink" href="#" class="addAddressLink">Add an Address</a>
                    {form controller=billing name=billingaddy action="setAddress"}
                    <div id="billingAddressPicker">
                        {foreach from=$addresses item=address}
                        <address id="addy{$address->id}" class="address {if $address->id == $billing->address->id}current {/if}bllAddSwp">
                        {$address->firstname} {$address->middlename} {$address->lastname}{br}
                        {$address->address1}{if $address->address2}, {$address->address2}{br}{else}{br}{/if}
                        {$address->city}, {$address->statename} {$address->zip}
                        </address>
                        {/foreach}
                    </div>
                    <div class="tohide">
                        {control type=dropdown class="addydd" name=billing_address id=billing_address label=" " items=$addresses_dd value=$billingaddy->id}
                        {control type=buttongroup name="shipSwitcher" submit=Change}
                    </div>
                    {/form}
                </div>
            </div> 
            <div id="addressform" class="exp-form">
                <div class="hd">Add a new address</div>
                <div class="bd"><span class="type-icon"></span>
                {form name="addaddy" controller=cart action=createaddress}
                    {control id=addresstype type=hidden name=addresstype value=""}
                    {control type=text name=firstname id=firstname label="First Name"}
                    {control type=text name=middlename id=middlename label="Middle Name"}
                    {control type=text name=lastname id=lastname label="Last Name"}
                    {control type=text name=organization id=organization label="Company/Organization"}
                    {control type=text name=phone id=phone label="Phone Number"}
                    {control type=text name=email id=email label="Email Address"}
                    {control type=text name=address1 id=address1 label="Address"}
                    {control type=text name=address2 id=address2 label=" "}
                    {control type=text name=city id=city label="City"}
                    {control type=state name=state id=state label="State"}
                    {control type=text name=zip id=zip label="Zip Code"}
                    {control type=buttongroup name="saveaddress" submit="Save Address"}
                {/form}
                {clear}
                </div>
            </div>
            {br}
            <h3>Payment Information</h3>
            <p>You’re paying by <strong>{$billing->calculator->payment_type}</strong> - <a id="billingeditlink" href="javascript:{ldelim}{rdelim};" class="exp-ecom-link">Enter Credit Card Information<span></span></a>

        
            {if $billing->available_calculators|@count > 1} 
            {* end split shipping *}
            
                <a class="changeselection" href="#">Change?</a>
                {form controller=billing action=selectBillingCalculator}
                    {control type=dropdown name=billingcalculator_id id=billingcalculator_id label=" " items=$billing->selectable_calculators includeblank="--- Choose a Payment Method ---" value=$billing->calculator->id}
                    {control type=buttongroup submit=Change}
                {/form}
            {/if}
            </p>
            
            <table id="ccinfotable" width="100%" border="0" cellspacing="0" cellpadding="5">
                {*<tr class="even">
                    <td width="100" class="ccinfotablelabel">Name on Card</td>
                    <td><span id="ccnameinfo">{$billing->calculator->opts->first_name|default:"Not yet provided..."} {$billing->calculator->opts->last_name}</span></td>
                </tr>*}
                <tr class="odd">
                    <td width="100" class="ccinfotablelabel">Card Type</td>
                    <td><span id="cctypeinfo">{$billing->calculator->opts->cc_type|default:"Not yet provided..."}</span></td>
                </tr>
                <tr class="even">
                    <td class="ccinfotablelabel">Card Number</td>
                    <td><span id="ccnuminfo">{$billing->calculator->opts->cc_number|default:"Not yet provided..."}</span></td>
                </tr>
                <tr class="odd">
                    <td class="ccinfotablelabel">Expiration</td>
                    <td><span id="ccexpminfo">{$billing->calculator->opts->exp_month|default:"Not yet provided..."}</span><span id="ccexpyinfo">{$billing->calculator->opts->exp_year}</span></td>
                </tr>
                <tr class="even">
                    <td class="ccinfotablelabel">CVV #</td>
                    <td><span id="cccvvinfo">{$billing->calculator->opts->cvv|default:"Not yet provided..."}</span></td>
                </tr>
            </table>
            
            <div id="ccpanel" class="exp-form">
                <div class="hd">Payment Information</div>
                <div class="bd"><span class="type-icon"></span>
                {if $billing->form != ""}
                    {form name="ccinfoform" controller=cart action=confirm}
                        {$billing->form}
                        <div class="tohide">
                            {control class="tohide" type=buttongroup submit="Checkout now!"}
                        </div>
                    {/form}
                    <div id="applyccinfocontrol" class="control">
                    <button class="button" id="applyccinfo">Apply Information</button>
                    </div>
                {/if}
                {clear}
                </div>
            </div>
        </div>
        <div class="separate">{*onclick="YAHOO.util.Dom.get('ccinfoform').submit();"*}
            <a class="exp-ecom-link-dis continue" href="#" id="checkoutnow"><em>Complete your checkout information to continue</em><span></span></a>
        </div>
    </div>
</div>
<div id="loadingdiv" class="loadingdiv">Loading Checkout Page</div>

{script unique="shoppingcartcheckout" yuimodules="animation,container,json" src=`$smarty.const.JS_FULL`exp-ecomcheckout.js}
//
{/script}
