{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}
<div id="order" class="module order show hide exp-skin-tabview">
    {script unique="order" yuimodules="tabview, element"}
    {literal}
        var tabView = new YAHOO.widget.TabView('ordertabs');     
        YAHOO.util.Dom.removeClass("order", 'hide');
        var loading = YAHOO.util.Dom.getElementsByClassName('loadingdiv', 'div');
        YAHOO.util.Dom.setStyle(loading, 'display', 'none');
    {/literal}
    {/script}
    
    <div id="ordertabs" class="yui-navset">
            <ul class="yui-nav">
                <li class="selected"><a href="#tab1"><em>Invoice</em></a></li>
                <li><a href="#tab2"><em>Order History</em></a></li>
                <li><a href="#tab3"><em>Shipping Information</em></a></li>
            </ul>            
            <div class="yui-content">
                <div id="tab1">
                    {printer_friendly_link text="Print this invoice" view="show_printable"} | {printer_friendly_link text="Print Packing Slip" view="show_packing"}
                    
                    {br}{br}
                    <table width=100% border="0" cellspacing="5" cellpadding="5">
                        <thead>
                        <tr>
                            <th colspan=2>
                                <h1>Invoice # {$order->invoice_id}</h1>
                                <span>Order was placed on: {$order->purchased|format_date:$smarty.const.DISPLAY_DATETIME_FORMAT}</span>
                            </th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr>
                            <td>
                                <h2>Billing Address</h2>
                                <address>
                                {$order->billingmethod[0]->firstname} {$order->billingmethod[0]->lastname}<br>
                                {if $order->billingmethod[0]->organization != ""}{$order->billingmethod[0]->organization}<br>{/if}
                                {if $order->billingmethod[0]->address1 != ""}{$order->billingmethod[0]->address1}{br}{/if}
                                {if $order->billingmethod[0]->address2 != ""}{$order->billingmethod[0]->address2}<br>{/if}
                                {$order->billingmethod[0]->city}{if $order->billingmethod[0]->state != ""}, {$order->billingmethod[0]->state|statename:abbv}{/if} {$order->billingmethod[0]->zip}<br>
                                {$order->billingmethod[0]->country}                                
                                {if $order->billingmethod[0]->phone != ""}{$order->billingmethod[0]->phone}<br>{/if}
                                {if $order->billingmethod[0]->email != ""}{$order->billingmethod[0]->email}<br>{/if}        
                                </address>
                                <br>
                            </td>
                            <td>
                                <h2>Shipping Address</h2>
                                {if $order->shipping_required == true}
                                    {if $order->shippingmethods|@count <= 1}
                                        <address>
                                        {$shipping->shippingmethod->firstname} {$shipping->shippingmethod->lastname}<br>
                                        {if $shipping->shippingmethod->organization != ""}{$shipping->shippingmethod->organization}<br>{/if}
                                        {if $shipping->shippingmethod->address1 != ""}{$shipping->shippingmethod->address1}<br>{/if}
                                        {if $shipping->shippingmethod->address2 != ""}{$shipping->shippingmethod->address2}<br>{/if}
                                        {$shipping->shippingmethod->city}{if $shipping->shippingmethod->state != ""}, {$shipping->shippingmethod->state|statename:abbv}{/if} {$shipping->shippingmethod->zip}<br>
                                        {$shipping->shippingmethod->country} 
                                        {if $shipping->shippingmethod->phone != ""}{$shipping->shippingmethod->phone}<br>{/if}
                                        {if $shipping->shippingmethod->email != ""}{$shipping->shippingmethod->email}<br>{/if}
                                        <br>
                                        </address>
                                    {else}
                                        See shipping information below.
                                    {/if}
                                {else}
                                    No shipping required for this order.
                                {/if}
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h2>Payment Method</h2>
                                {$billing->info}
                            </td>
                            <td>
                                <h2>Shipping Method</h2>
                                {if $order->shipping_required == true}
                                    {if $order->shippingmethods|@count <= 1}
                                        {$shipping->calculator->title} ({$shipping->shippingmethod->option_title}) - {currency_symbol}{$shipping->shippingmethod->shipping_cost|number_format:2}
                                        <br><br><br><br>
                                     {else}
                                        See shipping information below.
                                     {/if}
                                {else}
                                    No shipping required for this order.
                                {/if}
                            </td>
                        </tr>                        
                        <tr>
                        <td colspan=2>
                    <h3>Items</h3>
                    <ul>
                    {if $order->shippingmethods|@count > 1}
                    {foreach from=$order->shippingmethods item=method}
                        <li>
                            <h2>{$method->option_title} - ${$method->shipping_cost}</h2>                            
                            <h6>{$method->firstname} {$method->lastname} {$method->organization} {$method->address1} {$method->address2} {$method->city}, {$method->state|statename:abbv} {$method->zip}</h6>                            
                            <ul>
                            {foreach from=$method->orderitem item=oi}
                                <li>
                                    <a href="{link action=showByTitle controller="storeController" title=$oi->product->sef_url}">
                                        {if $oi->product->model != ""}{$oi->product->model} - {/if}
                                        {$oi->products_name}
                                    </a>
                                     - {$oi->quantity} at ${$oi->products_price|number_format:2} each
                                    {if $oi->opts[0]}
                                    <h4>Selected Options</h4>
                                    <ul style="padding:0 0 0 15px;margin:0 0 5px 0;">
                                        {foreach from=$oi->opts item=options}
                                            <li>{$options[1]}</li>
                                        {/foreach}
                                    </ul>
                                    {/if}
                                    {$oi->getExtraData()}                                
                                </li>
                            {/foreach}
                            </ul>
                        </li>
                        {if $method->to != "" || $method->from != "" || $method->message != ""}
                            <h3>Gift Message</h3>
                            <strong>To: </strong>{$method->to}{br}
                            <strong>From: </strong>{$method->from}{br}
                            <strong>Message: </strong>{$method->message}{br}
                        {/if}
                    {/foreach}
                    {else}
                        {foreach from=$order->orderitem item=oi}
                        <li>
                            <a href="{link action=showByTitle controller="storeController" title=$oi->product->sef_url}">
                                {if $oi->product->model != ""}{$oi->product->model} - {/if}
                                {$oi->products_name}
                            </a>
                             - {$oi->quantity} at ${$oi->products_price|number_format:2} each
                            {if $oi->opts[0]}
                            <h4>Selected Options</h4>
                            <ul style="padding:0 0 0 15px;margin:0 0 5px 0;">
                                {foreach from=$oi->opts item=options}
                                    <li>{$options[1]}</li>
                                {/foreach}
                            </ul>
                            {/if}
                            {$oi->getExtraData()}
                        </li>
                        {/foreach}
                        {assign var=sm value=$order->orderitem[0]->shippingmethod}
                        {if $sm->to != "" || $sm->from != "" || $sm->message != ""}
                        <h3>Gift Message</h3>
                        <strong>To: </strong>{$sm->to}{br}
                        <strong>From: </strong>{$sm->from}{br}
                        <strong>Message: </strong>{$sm->message}{br}
                        {/if}
                    {/if}
                    </ul>
                    </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td>
                            <table cellspacing=0 cellpadding=0>
                                <tbody>
                                <tr>
                                    <td>Sub Total</td>
                                    <td>{currency_symbol}{$order->total|number_format:2}</td>
                                </tr>
                                <tr>
                                    <td>
                                        Tax:
                                        {foreach from=$order->taxzones item=zone}
                                            {br}{$zone->name} ({$zone->rate}%)
                                        {foreachelse}
                                            {br}No Tax Required
                                        {/foreach}
                                    </td>
                                    <td>{currency_symbol}{$order->tax|number_format:2}</td>
                                </tr>
                                <tr>
                                    <td>Shipping</td>
                                    <td>{currency_symbol}{$order->shipping_total|number_format:2}</td>
                                </tr>
                                <tr>
                                    <td>Grand Total</td>
                                    <td>{currency_symbol}{$order->finalTotal|number_format:2}</td>
                                </tr>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                    </tbody>
                    </table>                    
                </div>
                <div id="tab2">
                    <h2>Order History</h2>
                    <h3>The status of this order is: {$order->getStatus()}</h3>
                    {permissions level=$smarty.const.UILEVEL_NORMAL}
                    {if $permissions.manage == 1}
                        {form action=setStatus}
                            {control type="hidden" name="id" value=$order->id}
                            {control type="dropdown" name="order_status_id" label="Change order status to:" frommodel='order_status' orderby='rank' value=$order->order_status_id}
                            {control type="checkbox" name="email_user" label="Send email to user to notify them of status change?" value=1}
                            {control type="checkbox" name="include_shipping_info" label="Include Shipping Information in email?" value=1}
                            <select id="order_status_messages" name="order_status_messages" size="1" onchange="populate_msgbox();">
                                <option value="0" selected>-- Select a predefined message --</option>
                                {foreach from=$messages item=msg}
                                    <option value="{$msg->body}">{$msg->body|truncate:80}</option>
                                {/foreach}
                            </select>
                            {control id=msgbox type="textarea" name="comment" label="Comment" rows=6 cols=45}
                            {control type="checkbox" name="save_message" label="Save this message to use in the future?" value=1}
                            {control type=buttongroup submit="Save change"}
                        {/form}
                    {/if}
                    {/permissions}
                    
                    <h3>History</h3>
                    {foreach from=$order->order_status_changes item=change}
                        <strong>
                        Status was changed from {selectValue table='order_status' field="title" where="id=`$change->from_status_id`"} 
                        to {selectValue table='order_status' field="title" where="id=`$change->to_status_id`"} on {$change->created_at|format_date:$smarty.const.DISPLAY_DATETIME_FORMAT}
                        </strong>
                        <h4>Comments</h4>
                        {$change->comment}{br}{br}
                    {foreachelse}
                        There is no change history for this order yet.
                    {/foreach}

                </div>
                <div id="tab3">
                    <h2>Shipping Information</h2>
                    {if $permissions.manage == 1}
                        {form action=update_shipping}
                            {control type="hidden" name="id" value=$order->id}
                            {control type="text" name="shipping_tracking_number" label="Tracking #" value=$order->shipping_tracking_number}
                            {control type="datetimecontrol" name="shipped" showtime=false label="Date Shipped" value=$order->shipped}
                            {control type="buttongroup" submit="Save Shipping Info"}
                        {/form}
                    {else}
                        Tracking #: {$order->shipping_tracking_number}{br}
                        Date Shipped: {if $order->shipped != 0}{$order->shipped|format_date:$smarty.const.DISPLAY_DATE_FORMAT}{else}This order has not been shipped yet{/if}
                    {/if}
                </div>
            </div>
        </div>
</div>
<div class="loadingdiv">Loading Order</div>

{script unique="msgbox"}
{literal}
    function populate_msgbox() {
        var dd = YAHOO.util.Dom.get('order_status_messages');
        var msgbox = YAHOO.util.Dom.get('comment');
        var idx = dd.selectedIndex;
        
        if (dd.options[idx].value == 0) {
            msgbox.value = '';
        } else {
            msgbox.value = dd.options[idx].value;
        }
        
    }
{/literal}
{/script}
