{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<table width=100% border="0" cellspacing="0" cellpadding="5">
    <thead>
    <tr>
        <th colspan=2 style="text-align:left;background:#ebe5d9;">
            <h1>Invoice # {$order->invoice_id}</h1>
            <span>Order was placed on: {$order->purchased|format_date:$smarty.const.DISPLAY_DATETIME_FORMAT}</span>
        </th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td width=50%>
            <h2>Billing Address</h2>
            <address>
            {$order->billingmethod[0]->firstname} {$order->billingmethod[0]->lastname}<br>
            {if $order->billingmethod[0]->organization != ""}{$order->billingmethod[0]->organization}<br>{/if}
            {if $order->billingmethod[0]->address1 != ""}{$order->billingmethod[0]->address1}{br}{/if}
            {if $order->billingmethod[0]->address2 != ""}{$order->billingmethod[0]->address2}<br>{/if}
            {$order->billingmethod[0]->city}{if $order->billingmethod[0]->state != ""}, {$order->billingmethod[0]->state|statename:abbv}{/if} {$order->billingmethod[0]->zip}<br>
            {$order->billingmethod[0]->country} 
            {if $order->billingmethod[0]->phone != ""}{$order->billingmethod[0]->phone}<br>{/if}
            {if $order->billingmethod[0]->email != ""}{$order->billingmethod[0]->email}<br>{/if}        
            <br>
            </address>
        </td>
        <td>
            <h2>Shipping Address</h2>
            {if $order->shipping_required == true}
                {if $order->shippingmethods|@count <= 1}
                    <address>
                    {$shipping->shippingmethod->firstname} {$shipping->shippingmethod->lastname}<br>
                    {if $shipping->shippingmethod->organization != ""}{$shipping->shippingmethod->organization}<br>{/if}
                    {if $shipping->shippingmethod->address1 != ""}{$shipping->shippingmethod->address1}<br>{/if}
                    {if $shipping->shippingmethod->address2 != ""}{$shipping->shippingmethod->address2}<br>{/if}
                    {$shipping->shippingmethod->city}{if $shipping->shippingmethod->state != ""}, {$shipping->shippingmethod->state|statename:abbv}{/if} {$shipping->shippingmethod->zip}<br>
                    {$shipping->shippingmethod->country} 
                    {if $shipping->shippingmethod->phone != ""}{$shipping->shippingmethod->phone}<br>{/if}
                    {if $shipping->shippingmethod->email != ""}{$shipping->shippingmethod->email}<br>{/if}
                    <br>
                    </address>
                {else}
                    See shipping information below.
                {/if}
            {else}
                No shipping required for this order.
            {/if}
        </td>
    </tr>
    <tr>
        <td style="text-align:left; white-space:nowrap">
            <h2>Payment Info</h2>
            {$billing->info}
        </td>
        <td>
            <h2>Shipping Method</h2>
            {if $order->shipping_required == true}
                {if $order->shippingmethods|@count <= 1}
                    {$shipping->calculator->title} ({$shipping->shippingmethod->option_title})
                    <br><br><br><br>
                 {else}
                    See shipping information below.
                 {/if}
            {else}
                No shipping required for this order.
            {/if}
        </td>
    </tr>
    <tr style="background:#cccccc">
        <td style="text-align:left; white-space:nowrap" colspan=2>
            <h3>Order Details</h3>
            {if $order->shippingmethods|@count > 1}
            {foreach from=$order->shippingmethods item=method}
                    <h2>{$method->option_title} - ${$method->shipping_cost}</h2>
                    <h6>{$method->firstname} {$method->lastname} {$method->organization} {$method->address1} {$method->address2} {$method->city}, {$method->state|statename:abbv} {$method->zip}</h6>
                    <ul>
                    {foreach from=$method->orderitem item=oi}
                        <li>
                        <a href="{link action=showByTitle controller="storeController" title=$oi->products_name}">{$oi->products_name}</a> x {$oi->quantity}
                        {if $oi->opts[0]}
                        <strong>Selected Options</strong>
                        <ul style="padding:0 0 0 15px;margin:0 0 5px 0;">
                            {foreach from=$oi->opts item=options}
                                <li>{$options[1]}</li>
                            {/foreach}
                        </ul>
                        {/if}
                        {$oi->getExtraData()}
                        </li>
                    {/foreach}
                    </ul>
            {/foreach}
            {else}
            <ul style="margin:0;padding:0 0 0 20px">
                {foreach from=$order->orderitem item=oi}
                <li>
                    <a href="{link action=showByTitle controller="storeController" title=$oi->products_name}">{$oi->products_name}</a> x {$oi->quantity}
                    {if $oi->opts[0]}{br}
                    <strong>Selected Options</strong>
                    <ul style="padding:0 0 0 15px;margin:0 0 5px 0;">
                        {foreach from=$oi->opts item=options}
                            <li>{$options[1]}</li>
                        {/foreach}
                    </ul>
                    {/if}        
                    {$oi->getExtraData()}
                </li>
            {/foreach}
            </ul>
            {/if}
        </td>
    </tr>
    </tbody>
</table>


