{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<div class="store show">
    <h1>{$product->title}</h1>
    <div class="image">
        {if $product->expFile.images[0]->url == ""}
            {img src="`$smarty.const.ICON_RELATIVE`ecom/no-image.jpg"}
        {else}
            {img file=$product->expFile.images[0]->path square=200}
        {/if}
        {clear}
    </div>

        {permissions level=$smarty.const.UILEVEL_PERMISSIONS}
        <div class="itemactions">
            {if $permissions.configure == 1 or $permissions.administrate == 1}
                <a href="{link action=edit id=$listing->id}" title="Edit this entry">
                    <img src="{$smarty.const.ICON_RELATIVE}edit.png" title="{$_TR.alt_edit}" alt="{$_TR.alt_edit}" />
                </a>
                {icon action="delete" img="delete.png" title="Delete this product" id=$listing->id}
            {/if}
        </div>
        {/permissions}

        <div class="bodycopy">{$product->body}</div>
        <div class="price">
            {if $product->availability_type == 4}
                <span class="label">Base Price: </span><span class="error">Call for price</span>{br}                    
            {else}
                <span class="label">Base Price: </span><span class="value">${$product->getPrice()|number_format:2}</span>{br}                    
            {/if}
        </div>
        
        {if $product->availability_type == 0}
            <a href="{link controller=cart action=addItem product_id=$product->id product_type=$product->product_type}" class="addtocart exp-ecom-link">Add to cart<span></span></a>
        {elseif $product->availability_type == 1}
            <a href="{link controller=cart action=addItem product_id=$product->id product_type=$product->product_type}" class="addtocart exp-ecom-link">Add to cart<span></span></a> 
            <span class="error">(Currently on back order)</span>    
        {elseif $product->availability_type == 2}    
            <span class="error">This product is out of stock</span>             
        {/if}    
        
    </div>
    {clear}
</div>
