{*
 * Copyright (c) 2004-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<div class="module faq showall">
    <h1>{$moduletitle|default:"Frequently Asked Questions"}</h1>
    
    {if $config.allow_user_questions}
        <a href="{link action="ask_question"}">Ask a question</a>    
    {/if}
    
    {if $config.use_toc}
        {foreach from=$questions item=question}
            <h5><a href="#faq_{$question->id}">{$question->question}</a></h5>
        {/foreach}
    {/if}
    
    <ul>
    {foreach from=$questions item=question}        
        <li>
            <h3><a name="faq_{$question->id}">{$question->question}</a></h3>
            <p>{$question->answer}</p>
        </li>
    {foreachelse}
        <li>There are currently no FAQ's</li>
    {/foreach}
    </ul>
    
    {permissions level=$smarty.const.UILEVEL_NORMAL}
        {if $permissions.create == 1}
            {icon class=add action=create title="Add a new FAQ" text="Add a New FAQ"}
        {/if}
        {br}
        {if $permissions.manage == 1}
            {icon action=manage title="Manage FAQs" text="Manage FAQs"}
        {/if}
    {/permissions}
</div>
