<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Adam Kessler
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class filedownloadController extends expController {
	//protected $basemodel_name = '';
	public $useractions = array('showall'=>'Show all');

	function name() { return $this->displayname(); } //for backwards compat with old modules
	function displayname() { return "File Downloads"; }
	function description() { return " This module lets you put files on your website for users to download."; }
	function author() { return "Adam Kessler - OIC Group, Inc"; }
	function hasSources() { return true; }
	function hasViews() { return true; }
	function hasContent() { return true; }
	function supportsWorkflow() { return false; }
	function isSearchable() { return true; }
	

    function showall() {
        expHistory::set('viewable', $this->params);
        $modelname = $this->basemodel_name;
        $where = $this->aggregateWhereClause();
        $limit = isset($this->config['limit']) ? $this->config['limit'] : null;
        $order = isset($this->config['order']) ? $this->config['order'] : 'rank';
        $dir   = isset($this->config['dir']) ? $this->config['dir'] : 'ASC';
        $page = new expPaginator(array(
                    'model'=>$modelname,
                    'where'=>$where, 
                    'limit'=>$limit,
                    'order'=>$order,
                    'dir'=>$dir,
                    'controller'=>$this->baseclassname,
                    'action'=>$this->params['action'],
                    'src'=>$this->loc->src,
                    'columns'=>array('ID#'=>'id','Title'=>'title', 'Body'=>'body'),
                    ));

        assign_to_template(array('page'=>$page, 'items'=>$page->records, 'modelname'=>$modelname));
    }
    
    public function downloadfile() {
        if (empty($this->params['fileid'])) {
            flash('error', 'There was an error while trying to download your file.  No File Specified.');
            expHistory::back();
        }
        
        $fd = new filedownload($this->params['fileid']);        
        if (empty($fd->expFile['downloadable'][0]->id)) {
            flash('error', 'There was an error while trying to download your file.  The file you were looking for could not be found.');
            expHistory::back();
        }        
        
        $fd->downloads += 1;
        $fd->save();
        
        // this will set the id to the id of the actual file..makes the download go right.
        $this->params['id'] = $fd->expFile['downloadable'][0]->id;
        parent::downloadfile();        
    }
    
    public function update() {
	    //FIXME:  Remove this code once we have the new tag implementation	    
	    if (!empty($this->params['tags'])) {
	        global $db;
	        if (isset($this->params['id'])) {
    	        $db->delete('content_expTags', 'content_type="filedownload" AND content_id='.$this->params['id']);
    	    }
    	    
	        $tags = explode(",", $this->params['tags']);
	        
	        foreach($tags as $tag) {
	            $tag = trim($tag);
	            $expTag = new expTag($tag);
	            if (empty($expTag->id)) $expTag->update(array('title'=>$tag));
	            $this->params['expTag'][] = $expTag->id;
	        }
	    }
	    // call expController update to save the file
	    parent::update();
	}
}

?>
