{*
 * Copyright (c) 2004-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<div class="module portfolio showall">
    {if $moduletitle != ""}<h1>{$moduletitle}</h1>{/if}
    {permissions level=$smarty.const.UILEVEL_NORMAL}
        {if $permissions.create == 1}
            <div class="addtotop">
                {icon class="add" action=edit rank=1 title="Add to the top" text="Add a portfolio piece to the top"}
            </div>
        {/if}
    {/permissions}    
    {$page->links}
    
    {foreach from=$page->records item=record}
        <div class="bodycopy">
            {img class="thumb" file_id=$record->expFile[0]->id square=150}
            <h2>{$record->title}</h2>
            <div class="tag">
                Tags: 
                {foreach from=$record->expTag item=tag name=tags}
                    <a href="{link action=showall_by_tags tag=$tag->sef_url}">{$tag->title}</a>
                    {if $smarty.foreach.tags.last != 1},{/if}
                {/foreach}
            </div>
            {if $config.truncate == 0 || $config.truncate == ""}
                {$record->body}
            {else}
                {$record->body|truncate:$config.truncate}
            {/if}
            <a class="oicbtn" href="{link action=show title=$record->sef_url}" title="View more about {$record->title}"><em>View {$record->title}</em></a>
            {permissions level=$smarty.const.UILEVEL_NORMAL}
                {if $permissions.edit == 1}
                    {icon img=edit.png action=edit id=$record->id title="edit `$modelname`"}
                {/if}
                {if $permissions.delete == 1}
                    {icon img=delete.png action=delete id=$record->id title="edit `$modelname`"}
                {/if}
                {if $permissions.edit == true}
                    {if $smarty.foreach.items.first == 0}
                        {icon action=rerank img=up.png id=$record->id push=up}    
                    {/if}
                    {if $smarty.foreach.items.last == 0}
                        {icon action=rerank img=down.png id=$record->id push=down}
                    {/if}
                {/if}
            {/permissions}
            <div style="clear:both"></div>
        </div>
        {permissions level=$smarty.const.UILEVEL_NORMAL}
            {if $permissions.create == 1}
                {icon class="add addhere" action=edit rank=`$text->rank+1` title="Add another here"  text="Add a portfolio piece here"}
            {/if}
        {/permissions}
    {/foreach}   
    {$page->links}
</div>
