<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Adam Kessler
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

class searchController extends expController {
    public $useractions = array('show'=>'Show Search Form');
    public $add_permissions = array('spider'=>'Spider Site');

    function name() { return $this->displayname(); } //for backwards compat with old modules
    function displayname() { return "Search Form"; }
    function description() { return "Add a form to allow users to search for content on your website."; }
    function author() { return "Adam Kessler - OIC Group, Inc"; }
    function hasSources() { return false; }
    function hasViews() { return true; }
    function hasContent() { return false; }
    function supportsWorkflow() { return false; }
    function isSearchable() { return false; }

    public function search() {
        $terms = $this->params['search_string'];
        $search = new search();
        $page = new expPaginator(array(
			'model'=>'search',
			'controller'=>$this->params['controller'],
			'action'=>$this->params['action'],
			'records'=>$search->getSearchResults($terms),
			//'sql'=>$sql,
			'order'=>'score',
			'dir'=>'DESC',
			));        

        assign_to_template(array('page'=>$page, 'terms'=>$terms));
    }
    
    public function spider() {
        global $db;
	    $db->delete('search');
	    
	    $searchable_mods = array();
	    $unsearchable_mod = array();

	    //FIXME: Old school module code!
	    foreach (exponent_modules_list() as $mod) {
		    $name = @call_user_func(array($mod,'name'));
		    if (class_exists($mod) && is_callable(array($mod,'spiderContent'))) {
			    if (call_user_func(array($mod,'spiderContent'))) {
				    $mods[$name] = 1;
			    }
		    } else {
			    //$mods[$name] = 0;
		    }
	    }

	    foreach (listControllers() as $ctlname=>$ctl) {
		    $controller = new $ctlname();		    
		    if ($controller->isSearchable()) {
			    $mods[$controller->name()] = $controller->addContentToSearch();
		    } else {
		        //$mods[$controller->name()] = 0;
		    }
	    }
	
	    uksort($mods,'strnatcasecmp');
	    assign_to_template(array('mods'=>$mods));
    }
        
    public function show() {
        //no need to do anything..we're just showing the form
    }
    
    public function showall() {
        redirect_to(array("controller"=>'search',"action"=>'show'));
    }
    
}

?>
