{*
 * Copyright (c) 2007-2008 OIC Group, Inc.
 * Written and Designed by Adam Kessler
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}

<div class="module users manage-extensions">
	<h1>{$moduletitle|default:"Manage User Profile Extensions"}</h1>	
	<p>
        From here activate or deactivate user profile extensions.  User profile extensions are used to 
        give users the ability to put in more information about themselves.  The active extensions will 
        add fields to the form a user has to fill out to create an account.
    </p>

	{$page->links}
	<table class="exp-skin-table">
	    <thead>
		<tr>
		    {$page->header_columns}
			<th>&nbsp;</th>
		</tr>
		</thead>
		<tbody>
			{foreach from=$page->records item=listing name=listings}
			<tr class="{cycle values="odd,even"}">
				<td>{$listing->title}</td>
				<td>{$listing->body}</td>
				<td>
                    {if $listing->active}
                        <a href="{link action=toggle_extension id=$listing->id}">{img src=`$smarty.const.ICON_RELATIVE`toggle_on.gif}</a>
                    {else}
                        <a href="{link action=toggle_extension id=$listing->id}">{img src=`$smarty.const.ICON_RELATIVE`toggle_off.gif}</a>
                    {/if}
				</td>
			    <td>
			        {permissions level=$smarty.const.UILEVEL_PERMISSIONS}
                    <div class="itemactions">
                    {if $permissions.edit == true}
                        {icon controller=$page->controller action=edit id=$user->id title="Edit"}
                    {/if}
                    {if $permissions.delete == true}
                        {icon controller=$page->controller action=delete id=$user->id title="Delete" onclick="return confirm('Are you sure you want to delete this user?');"}
                    {/if}
                    </div>
                    {/permissions}
			    </td>
			</tr>
			{foreachelse}
			    <td colspan="{$page->columns|count}">No Data.</td>
			{/foreach}
		</tbody>
		</table>
		{$page->links}
	</div>
</div>
