{*
 * Copyright (c) 2004-2006 OIC Group, Inc.
 * Copyright (c) 2005-2006 Maxim Mueller
 * Written and Designed by James Hunt
 *
 * This file is part of Exponent
 *
 * Exponent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU
 * General Public License as published by the Free
 * Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * GPL: http://www.gnu.org/licenses/gpl.txt
 *
 *}
<html>
    <head>
        <title>{$_TR.form_title}</title>
        
        <style type="text/css">
            {literal}
            body {
                margin: 0px;
                padding: 0px;
            }
            h2 {
                margin:3px 0;
            }
            div.imagecollection_sidebar {
                background-color: #666;
                border-right: 2px solid black;
                border-bottom: 2px solid black;
                font-size: 11pt;
                position: absolute;
                left: 0px;
                top: 0px;
                padding: 1em;
                padding-left: .5em;
                padding-top: .5em;
                width: 200px;
            }

            div.imagecollection_sidebar ul {
                margin: 0px;
                padding: 0px;
            }
            div.imagecollection_sidebar ul li {
                list-style: none;
            }

            div.imagecollection_sidebar a {
                color: white;
                text-decoration: none;
                font-weight: bold;
            }

            div.imagecollection_sidebar a:hover {
                color: black;
                text-decoration: underline;
                font-weight: bold;
            }

            div.imagecollection_previews {
                padding: 1em;
                margin-bottom: 30px;
            }

            div.scroller {
                width: 650px;
                height: 600px;
                overflow: auto;
            }

            div.imagecollection_previews table tr td {
                text-align: center;
                border: 1px solid #666;
                font-size: 10px;
                padding: 1px;
            }

            div.imagecollection_previews table tr td a {
                text-decoration: none;
                color: darkblue;
                font-weight: bold;
            }

            div.imagecollection_upload {
                background-color: #999;
                border-top: 2px solid black;
                padding: .2em;
                text-align: center;
                font-size: 11px;
                position: fixed;
                bottom: 0px;
                left: 0px;
                height: 30px;
                width:100%
            }

            div.imagecollection_previews table tr td img {
                border: 1px solid white;
            }

            div.imagecollection_previews table tr td#highlight img {
                background-color: #CCC;
                border: 6px solid black;
            }

            div.imagecollection_previews table tr td:hover img {
                border: 1px solid black;
            }
            {/literal}
        </style>
        <script type="text/javascript" src="../../../external/yui/build/yuiloader-dom-event/yuiloader-dom-event.js"></script>
        
        <link rel="stylesheet" type="text/css" href="http://yui.yahooapis.com/2.6.0/build/paginator/assets/skins/sam/paginator.css" />
        <link rel="stylesheet" type="text/css" href="http://yui.yahooapis.com/2.6.0/build/datatable/assets/skins/sam/datatable.css" />

        <script type="text/javascript" src="../../../external/yui/build/element/element-beta-min.js"></script>
        <script type="text/javascript" src="../../../external/yui/build/paginator/paginator-min.js"></script>
        <script type="text/javascript" src="../../../external/yui/build/datasource/datasource-min.js"></script>
        <script type="text/javascript" src="../../../external/yui/build/datatable/datatable-min.js"></script>
        
        
        
        <script type="text/javascript" src="../../../exponent.js.php"></script>
        <script type="text/javascript">
        {literal}


            function openWindow(filename,width,height) {
                if (width != 0) {
                    width = width+40;
                    if (width > 600) width = 600;
                } else {
                    width = 400;
                }

                if (height != 0) {
                    height = height+40;
                    if (height > 400) height = 400;
                } else {
                    height = 400;
                }

                //window.open(filename,'image'+Math.random(),'status=no,status=no,width='+width+',height='+height);
                window.open(filename,'image'+Math.random(),'status=yes,status=yes,width='+width+',height='+height);
                return false;
            }
        {/literal}
        </script>
    </head>
    <body class="yui-skin-sam">
        <h2>{gettext str="File Manager"} ({$numfiles} {plural singular=file plural=files count=$numfiles})</h2>
        <div class="imagecollection_previews" id="markup">
            <table width="100%" id="expfiles">
                <thead>
                    <th>File</th>
                    <th>File Name</th>
                    <th>Use</th>
                    <th>Delete</th>
                </thead>
                <tbody>
                {foreach name=i from=$files item=file}
                <tr>
                    <td>
                        {if $file->is_image}
                            <a href="{$smarty.const.PATH_RELATIVE}{$file->directory}/{$file->filename}" onclick="return openWindow('{$smarty.const.PATH_RELATIVE}{$file->directory}/{$file->filename}',{$file->image_width},{$file->image_height});" target="_blank">
                                <img src="{$smarty.const.PATH_RELATIVE}thumb.php?id={$file->id}&constraint=1&width=40&height=25" title="Click to view" alt="Click to view" border="0"/>
                            </a>
                        {else}
                            {getfileicon id=$file->id}
                        {/if}
                    </td>
                    <td>
                        {if $file->name == ''}
                            {$file->filename}
                        {else}
                            {$file->name}
                        {/if}
                    </td>
                    <td>
                        <a href="#" onclick="window.opener.YAHOO.pagetalk.passBackFile{$update}('{$file->id}'); window.close(); return false;">
                            Use this file
                        </a>
                    </td>

					<td>
						<a href="{link action=delete update=$smarty.get.update id=$file->id module=filemanagermodule manager="true"}" onclick="return confirm('Are you sure you want to delete this file?');"><img class="mngmnt_icon" style="border:none;" src="{$smarty.const.ICON_RELATIVE}delete.png" title="{$_TR.delete_desc}" alt="{$_TR.delete_desc}" /></a>
					</td>
				</tr>
					{foreachelse}
				<tr>
					<td><i>{$_TR.no_files}</i></td>
				</tr>
					{/foreach}
                </tbody>
            </table>
        </div>
        <div class="imagecollection_upload">
		
			<form method="post" action="manager_upload.php" enctype="multipart/form-data">
			<input type="hidden" name="collection_id" value="{$collection->id}" />
			<input type="hidden" name="update" value="{$smarty.get.update}" />
            <input type="hidden" name="name" value="" />
            {$_TR.img_upload} <input type="file" name="file" />
            <input type="submit" value="Go" />
            </form>
        </div>
        <script type="text/javascript">
        {literal}

        YAHOO.util.Event.addListener(window, "load", function() {
            YAHOO.example.EnhanceFromMarkup = function() {
                var myColumnDefs = [
                    {key:"file",label:"File",sortable:true},
                    {key:"file name",label:"Filename", sortable:true},
                    {key:"use",label:"Use",sortable:true},
                    {key:"delete",label:"Delete"}
                ];

                var myDataSource = new YAHOO.util.DataSource(YAHOO.util.Dom.get("expfiles"));
                myDataSource.responseType = YAHOO.util.DataSource.TYPE_HTMLTABLE;
                myDataSource.responseSchema = {
                    fields: [{key:"file"},
                            {key:"file name"},
                            {key:"use"},
                            {key:"delete"}
                    ]
                };

                var myDataTable = new YAHOO.widget.DataTable("markup", myColumnDefs, myDataSource,
                        {//caption:"My Files",
                        sortedBy:{key:"file",dir:"desc"},
                        paginator: new YAHOO.widget.Paginator({rowsPerPage: 10}),
                        width:"100%"
                        }
                );

                return {
                    oDS: myDataSource,
                    oDT: myDataTable
                };
            }();
        });
        {/literal}
        </script>
        
    </body>
</html>
