<?php

##################################################
#
# Copyright (c) 2004-2006 OIC Group, Inc.
# Written and Designed by Phillip Ball
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

function smarty_function_ddrerank($params,&$smarty) {
	$loc = $smarty->_tpl_vars['__loc'];
	
    $badvals = array("[", "]", ",", " ", "'", "\"", "&", "#", "%", "@", "!", "$", "(", ")", "{", "}");
    $uniqueid = str_replace($badvals, "", $loc->src).$params['id'];
    $model = empty($params['model']) ? $params['items'][0]->classname : $params['model'] ;
    $sortfield = empty($params['sortfield']) ? 'title' : $params['sortfield'];
    
    echo '<a id="rerank'.$uniqueid.'" class="reranklink" href="#">Order '.$params['label'].'</a>';

    $html = '
    <div id="panel'.$uniqueid.'" class="exp-panel exp-panel-rerank hide">
        <div class="hd">Order '.$params['label'].'</div>
        <div class="bd">
        <form method="post" action="'.URL_FULL.'">
        <input type="hidden" name="model" value="'.$model.'" />
        <input type="hidden" name="controller" value="'.$loc->mod.'" />
        <input type="hidden" name="src" value="'.$loc->src.'" />
        <input type="hidden" name="action" value="manage_ranks" />
        <ul id="listToOrder'.$uniqueid.'">
        ';
        $odd = "even";
        foreach ($params['items'] as $item) {
            $html .= '
            <li class="'.$odd.'">
            <input type="hidden" name="rerank[]" value="'.$item->id.'" />
            <div class="fpdrag"></div>
            <img class="filepic" src="'.URL_FULL.'thumb.php?id='.$item->expFile[0]->id.'&square=24">
            <div class="filename">'.substr($item->$sortfield, 0, 40).'</div>
            </li>';
            $odd = $odd == "even" ? "odd" : "even";
        }
            
    $html .='</ul>
        <input type="submit" value="Submit">
        </form>
        </div>
    </div>
    ';
    
    echo $html;
    
    $script = '
    var ropanel'.$uniqueid.' = new YAHOO.widget.Panel("panel'.$uniqueid.'", { width:"400px",y:100,zindex:50,visible:false, constraintoviewport:true } );
	ropanel'.$uniqueid.'.render(document.body);
	YAHOO.util.Dom.removeClass("panel'.$uniqueid.'", \'hide\');
	
	
    YAHOO.util.Event.on("rerank'.$uniqueid.'", "click", function(e){
        YAHOO.util.Event.stopEvent(e);
    	ropanel'.$uniqueid.'.show();
    });
    
    YUI({base:EXPONENT.URL_FULL+\'/external/yui3/build/\'}).use(\'dd-constrain\', \'dd-proxy\', \'dd-drop\', function(Y) {
    
        //Drag Drop stuff
        
        //Listen for all drop:over events
        Y.DD.DDM.on(\'drop:over\', function(e) {
            //Get a reference to out drag and drop nodes
            var drag = e.drag.get(\'node\'),
                drop = e.drop.get(\'node\');

            //Are we dropping on a li node?
            if (drop.get(\'tagName\').toLowerCase() === \'li\') {
                //Are we not going up?
                if (!goingUp) {
                    drop = drop.get(\'nextSibling\');
                }
                //Add the node to this list
                e.drop.get(\'node\').get(\'parentNode\').insertBefore(drag, drop);
                //Resize this nodes shim, so we can drop on it later.
                e.drop.sizeShim();
            }
        });
        //Listen for all drag:drag events
        Y.DD.DDM.on(\'drag:drag\', function(e) {
            //Get the last y point
            var y = e.target.lastXY[1];
            //is it greater than the lastY var?
            if (y < lastY) {
                //We are going up
                goingUp = true;
            } else {
                //We are going down..
                goingUp = false;
            }
            //Cache for next check
            lastY = y;
        });
        //Listen for all drag:start events
        Y.DD.DDM.on(\'drag:start\', function(e) {
            //Get our drag object
            var drag = e.target;
            //Set some styles here
            drag.get(\'node\').setStyle(\'opacity\', \'.25\');
            drag.get(\'dragNode\').set(\'innerHTML\', drag.get(\'node\').get(\'innerHTML\'));
            drag.get(\'dragNode\').setStyles({
                opacity: \'.5\',
                borderColor: drag.get(\'node\').getStyle(\'borderColor\'),
                backgroundColor: drag.get(\'node\').getStyle(\'backgroundColor\')
            });
        });
        //Listen for a drag:end events
        Y.DD.DDM.on(\'drag:end\', function(e) {
            var drag = e.target;
            //Put out styles back
            drag.get(\'node\').setStyles({
                visibility: \'\',
                opacity: \'1\'
            });
        });
        //Listen for all drag:drophit events
        Y.DD.DDM.on(\'drag:drophit\', function(e) {
            var drop = e.drop.get(\'node\'),
                drag = e.drag.get(\'node\');

            //if we are not on an li, we must have been dropped on a ul
            if (drop.get(\'tagName\').toLowerCase() !== \'li\') {
                if (!drop.contains(drag)) {
                    drop.appendChild(drag);
                }
            }
        });

        //Static Vars
        var goingUp = false, lastY = 0;

        //Get the list of lis in the lists and make them draggable
        var lis = Y.Node.all(\'#listToOrder'.$uniqueid.' li\');
        if (lis){
            lis.each(function(v, k) {
                var dd = new Y.DD.Drag({
                    node: v,
                    proxy: true,
                    moveOnEnd: false,
                    constrain2node: \'#listToOrder'.$uniqueid.'\',
                    target: {
                        padding: \'0 0 0 20\'
                    }
                }).addHandle(\'.fpdrag\');
            });
            
        }

        //Create simple targets for the 2 lists..
        var uls = Y.Node.all(\'#listToOrder'.$uniqueid.'\');
        uls.each(function(v, k) {
            var tar = new Y.DD.Drop({
                node: v
            });
        });

    });
    
    
    ';
    
    exponent_javascript_toFoot($smarty->_tpl_vars[__loc]->src, 'container', null, $script, null);
}

?>

