<?php

##################################################
#
# Copyright (c) 2004-2008 OIC Group, Inc.
# Written and Designed by Phillip Ball
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# GPL: http://www.gnu.org/licenses/gpl.txt
#
##################################################

if (!defined('EXPONENT')) exit('');

/**
 * HTML Control
 *
 * @author phillip ball
 * @copyright 2004-2008 OIC Group, Inc.
 * @version 0.95
 *
 * @package Subsystems
 * @subpackage Forms
 */

/**
 * Manually include the class file for formcontrol, for PHP4
 * (This does not adversely affect PHP5)
 */
require_once(BASE."subsystems/forms/controls/formcontrol.php");

/**
 * HTML Control
 *
 * @package Subsystems
 * @subpackage Forms
 */
class filemanagercontrol extends formcontrol {
    var $html;
    var $span;
    
    function name() { return "Manage Files"; }
    function isSimpleControl() { return true; }
    
    function __construct($subtype=null, $html = "",$span = true) {
        $this->span = $span;
        $this->html = $html;
        $this->subtype = isset($subtype) ? $subtype : '';
    }

    function toHTML($label,$name) {
        $subTypeName = empty($this->subtype) ? "expFile[]" : "expFile[".$this->subtype."][]";
        $files = $this->buildImages();
        $html = '<div id="filemanager'.$name.'" class="filemanager control">';
        //$html .= '<div id="displayfiles" class="displayfiles" style="padding:5px; border:1px solid #444"> </div>';
        $html .= '<div class="hd"><strong>'.$label.'</strong><a class="add" href="#" id="addfiles-'.$name.'">Add Files</a></div>';
        if ($files) {
            $html .= '<div id="tbhd'.$name.'" class="tbhd"><span class="rank">Rank</span><span class="file">File</span><span class="fname">File Name</span></div>';
        } else {
            $html .= '<div id="tbhd'.$name.'" class="tbhd"><strong>No files currently attached</strong></div>';
        }
        $html .= '<ul id="filelist'.$name.'">';
        $html .= $files;
        $html .= '</ul>';
        $html .= '<input type="hidden" name="'.$subTypeName.'" value="'.$subTypeName.'">';
        $html .= '</div>';
        $js = "
            YUI({base:EXPONENT.URL_FULL+'/external/yui3/build/'}).use('dd-constrain', 'dd-proxy', 'dd-drop', function(Y) {
            
                YAHOO.util.Event.on('addfiles-".$name."', 'click', function (e){
                    YAHOO.util.Event.stopEvent(e);
                    win = window.open('".makeLink($params=array('controller'=>'file','action'=>'picker','ajax_action'=>"1",'update'=>$name))."', 'IMAGE_BROWSER','left=20,top=20,scrollbars=no,width=800,height=600,toolbar=no,resizable=0,status=0');
                    if (!win) {
                        //Catch the popup blocker
                        alert('Please disable your popup blocker!!');
                    }
                                
                    EXPONENT.passBackFile".$name." = function(id) {
                    
                        var ej = new EXPONENT.AjaxEvent();
                        ej.subscribe(function (o) {
                            var df = YAHOO.util.Dom.get('filelist".$name."');
                            var obj = o.data;
                            if (obj.mimetype!='image/png' && obj.mimetype!='image/gif' && obj.mimetype!='image/jpeg'){
                                var filepic = '<img class=\"filepic\" src=\"'+EXPONENT.ICON_RELATIVE+'\"attachableitems/generic_22x22.png\">';
                            } else {
                                var filepic = '<img class=\"filepic\" src=\"'+EXPONENT.URL_FULL+'thumb.php?id='+obj.id+'&square=24\">';
                            }
                        
                            var html = '<li class=\"odd\" id=\"imgdiv'+obj.id+'\">';
                            html += '<input type=\"hidden\" name=\"".$subTypeName."\" value=\"'+obj.id+'\">';
                            html += '<div class=\"fpdrag\"></div>';
                            html += filepic;
                            html += '<div class=\"filename\">'+obj.filename+'</div>';
                            html += '<a class=\"deletelinks\" rel=\"imgdiv'+obj.id+'\" href=\"javascript:{}\"><img src=\"".ICON_RELATIVE."attachableitems/delete.png\"></a>';
                            html += '</li>';

                            df.innerHTML = df.innerHTML+ html;
                            var header = YAHOO.util.Dom.get('tbhd".$name."');
                            header.innerHTML = '<span class=\"rank\">Rank</span><span class=\"file\">File</span><span class=\"fname\">File Name</span>';

                        });
                        ej.fetch({action:'getFile',controller:'fileController',json:1,params:'&id='+id});

                    }
                
                });
            
                YAHOO.util.Event.on('filelist".$name."', 'click', function(e){
                    YAHOO.util.Event.stopEvent(e);
                    var targ = YAHOO.util.Event.getTarget(e);
                    while (targ.id != 'displayfiles-".$name."') {
                        if(YAHOO.util.Dom.hasClass(targ, 'deletelinks') != false) {
                            var dtop = YAHOO.util.Dom.get('filelist".$name."');
                            var drem = YAHOO.util.Dom.get(targ.rel);
                            dtop.removeChild(drem);
                            break;
                        } else {
                            targ = targ.parentNode;
                        }
                    }
                });


                //Drag Drop stuff
                
                //Listen for all drop:over events
                Y.DD.DDM.on('drop:over', function(e) {
                    //Get a reference to out drag and drop nodes
                    var drag = e.drag.get('node'),
                        drop = e.drop.get('node');

                    //Are we dropping on a li node?
                    if (drop.get('tagName').toLowerCase() === 'li') {
                        //Are we not going up?
                        if (!goingUp) {
                            drop = drop.get('nextSibling');
                        }
                        //Add the node to this list
                        e.drop.get('node').get('parentNode').insertBefore(drag, drop);
                        //Resize this nodes shim, so we can drop on it later.
                        e.drop.sizeShim();
                    }
                });
                //Listen for all drag:drag events
                Y.DD.DDM.on('drag:drag', function(e) {
                    //Get the last y point
                    var y = e.target.lastXY[1];
                    //is it greater than the lastY var?
                    if (y < lastY) {
                        //We are going up
                        goingUp = true;
                    } else {
                        //We are going down..
                        goingUp = false;
                    }
                    //Cache for next check
                    lastY = y;
                });
                //Listen for all drag:start events
                Y.DD.DDM.on('drag:start', function(e) {
                    //Get our drag object
                    var drag = e.target;
                    //Set some styles here
                    drag.get('node').setStyle('opacity', '.25');
                    drag.get('dragNode').set('innerHTML', drag.get('node').get('innerHTML'));
                    drag.get('dragNode').setStyles({
                        opacity: '.5',
                        borderColor: drag.get('node').getStyle('borderColor'),
                        backgroundColor: drag.get('node').getStyle('backgroundColor')
                    });
                });
                //Listen for a drag:end events
                Y.DD.DDM.on('drag:end', function(e) {
                    var drag = e.target;
                    //Put out styles back
                    drag.get('node').setStyles({
                        visibility: '',
                        opacity: '1'
                    });
                });
                //Listen for all drag:drophit events
                Y.DD.DDM.on('drag:drophit', function(e) {
                    var drop = e.drop.get('node'),
                        drag = e.drag.get('node');

                    //if we are not on an li, we must have been dropped on a ul
                    if (drop.get('tagName').toLowerCase() !== 'li') {
                        if (!drop.contains(drag)) {
                            drop.appendChild(drag);
                        }
                    }
                });

                //Static Vars
                var goingUp = false, lastY = 0;

                //Get the list of li's in the lists and make them draggable
                var lis = Y.Node.all('#filelist".$name." li');
                if (lis){
                    lis.each(function(v, k) {
                        var dd = new Y.DD.Drag({
                            node: v,
                            proxy: true,
                            moveOnEnd: false,
                            constrain2node: '#filelist".$name."',
                            target: {
                                padding: '0 0 0 20'
                            }
                        }).addHandle('.fpdrag');
                    });
                    
                }

                //Create simple targets for the 2 lists..
                var uls = Y.Node.all('#filelist".$name."');
                uls.each(function(v, k) {
                    var tar = new Y.DD.Drop({
                        node: v
                    });
                });

            });
            "; // END PHP STRING LITERAL
        exponent_javascript_toFoot("filepicker".$name,"json,connection","files-".$name,$js,"");
        return $html;
    }
    
    function buildImages() {
        if (empty($this->value)) return null;

        //get the array of files
        $filearray = empty($this->subtype) ? $this->value : $this->value[$this->subtype];
        if (empty($filearray)) return null;
        
        $subTypeName = empty($this->subtype) ? "expFile[]" : "expFile[".$this->subtype."][]";
        // loop over each file and build out the HTML
        $cycle = "odd";
        foreach($filearray as $val) {
            if ($val->mimetype!="image/png" && $val->mimetype!="image/gif" && $val->mimetype!="image/jpeg"){
                $filepic = "<img class=\"filepic\" src='".ICON_RELATIVE."attachableitems/generic_22x22.png'>";
            } else {
                $filepic = "<img class=\"filepic\" src=".URL_FULL."thumb.php?id=".$val->id."&square=24\">";
            }
            $html .= "<li class=\"".$cycle."\" id=\"imgdiv".$val->id."\">";
            $html .= "<input type=\"hidden\" name=\"".$subTypeName."\" value=\"".$val->id."\">";
            $html .= "<div class=\"fpdrag\"></div>";
            $html .= $filepic;
            $html .= "<div class=\"filename\">".$val->filename."</div>";
            $html .= "<a class=\"deletelinks\" rel=\"imgdiv".$val->id."\" href='javascript:{}'><img src='".ICON_RELATIVE."attachableitems/delete.png'></a>";
            $html .= "</li>";
            $cycle = $cycle=="odd" ? "even" : "odd";
        }
        
        return $html;
    }
    
    function controlToHTML($name) {
        return $this->html;
    }
    
    function form($object) {
        if (!defined("SYS_FORMS")) require_once(BASE."subsystems/forms.php");
        exponent_forms_initialize();
    
        $form = new form();
        if (!isset($object->html)) {
            $object->html = "";
        } 
        
        $i18n = exponent_lang_loadFile('subsystems/forms/controls/htmlcontrol.php');
        
        $form->register("html",'',new htmleditorcontrol($object->html));
        $form->register("submit","",new buttongroupcontrol($i18n['save'],'',$i18n['cancel']));
        return $form;
    }
    
    function update($values, $object) {
        if ($object == null) $object = new htmlcontrol();
        $object->html = preg_replace("/<br ?\/>$/","",trim($values['html']));
        $object->caption = '';
        $object->identifier = uniqid("");
        $object->is_static = 1;
        return $object;
    }
    
}

?>
